/*
*  BackupCpyDlgs.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef BackupCpyDlgsH
#define BackupCpyDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------
bool __fastcall DoBackupDatabase(TForm *Owner, AnsiString path, AnsiString dbname,
   int copies, int passes, bool verify);
bool __fastcall DoRestoreDatabase(TForm *Owner, AnsiString dbName, AnsiString BakFile);

class TBackupCpyDlg : public TForm
{
__published:	// IDE-managed Components
	TPanel *Display;
	TTimer *Timer1;
        TTimer *Timer2;
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);

        void __fastcall Timer2Timer(TObject *Sender);
private:	// User declarations
public:		// User declarations
   int copies,passes;
   unsigned starttick;
   bool isbackup, verify;
   AnsiString path,name,bakfile,displaymsg,errorstr,caption;
   __fastcall TBackupCpyDlg(TComponent* Owner);

   bool __fastcall copyfile(const AnsiString &Existing, const AnsiString &NewName);
   bool __fastcall comparefiles(const AnsiString &File1, const AnsiString File2);

   bool __fastcall ExecuteBackup(AnsiString Path, AnsiString Name, int Copies, int Passes, bool Verify);
   bool __fastcall ExecuteRestore(AnsiString Name, AnsiString BakFile);
   void __fastcall FlashMessage(AnsiString msg);
   void __fastcall StartFlashMessage(AnsiString msg);
   void __fastcall StopFlashMessage();
   bool __fastcall RestoreDatabase();
   bool __fastcall BackupDatabase();
};

// Flash Thread ------------------------------------------------------------
class TBKFlashThread : public TThread
{
private:
protected:
   void __fastcall Execute();
public:
   TPanel *display;
   AnsiString message;
   virtual __fastcall TBKFlashThread(bool CreateSuspended);
   virtual __fastcall TBKFlashThread(TPanel *Display); //, const AnsiString &Message);
   void __fastcall FlashMessage();
};

// Zap Thread --------------------------------------------------------------
void  __fastcall DoThreadZap(AnsiString Filename, int Zapcount);
class TZapThread : public TThread
{
protected:
	void __fastcall Execute();
public:
   int zaps;
   AnsiString filename;
   __fastcall TZapThread(bool CreateSuspended);
};

// Copy Thread -------------------------------------------------------------
void  __fastcall DoThreadCopy(TBackupCpyDlg *Owner, AnsiString Filename, AnsiString Copyname);
class TCopyThread : public TThread
{
protected:
	void __fastcall Execute();
public:
   TBackupCpyDlg *owner;
   AnsiString filename,copyname,errorstr;
   __fastcall TCopyThread(bool CreateSuspended);
   void __fastcall Terminate(TObject *Sender);
};
//---------------------------------------------------------------------------
extern TBackupCpyDlg *BackupCpyDlg;
//---------------------------------------------------------------------------
#endif
