/*
*  BackupDlgs.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef BackupDlgsH
#define BackupDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\FileCtrl.hpp>
#include <vcl\Menus.hpp>
//---------------------------------------------------------------------------
bool __fastcall BackupQuickSilverData(TForm *Owner, bool SecureMode);
bool __fastcall BackupQuickSilverDataAuto(TForm *Owner);

class TBackupDlg : public TForm
{
__published:	// IDE-managed Components
	TButton *OkBtn;
	TButton *CancelBtn;
	TTimer *Timer1;
	TPageControl *PageControl1;
	TTabSheet *TabSheet1;
	TTabSheet *TabSheet2;
	TLabel *Label1;
	TLabel *Label2;
	TLabel *Label3;
	TRadioButton *DbcDB;
	TRadioButton *PgpDB;
	TEdit *BackupCopies;
	TLabel *Label5;
	TUpDown *UpDown;
	TLabel *Label4;
	TEdit *BackupPath;
	TButton *BrowseBtn;
	TLabel *Label6;
	TLabel *Label7;
	TDirectoryListBox *DirectoryListBox1;
	TDriveComboBox *DriveComboBox1;
	TLabel *Label9;
	TLabel *Label8;
	TPopupMenu *PopupMenu1;
	TMenuItem *PopDeleteItem;
	TButton *HelpBtn;
	TListBox *ListBox1;
	TEdit *WipePasses;
	TUpDown *UpDown1;
	TLabel *Label10;
        TCheckBox *AutoBackupBox;
        TTimer *Timer2;
        TCheckBox *VerifyBox;
	void __fastcall OkBtnClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall CancelBtnClick(TObject *Sender);
	void __fastcall BrowseBtnClick(TObject *Sender);
	void __fastcall PageControl1Change(TObject *Sender);
	void __fastcall PopupMenu1Popup(TObject *Sender);
	void __fastcall PopDeleteItemClick(TObject *Sender);
	void __fastcall FileListBox1DblClick(TObject *Sender);
	void __fastcall HelpBtnClick(TObject *Sender);
	void __fastcall DirectoryListBox1Change(TObject *Sender);
	void __fastcall ListBox1DrawItem(TWinControl *Control, int Index, TRect &Rect,
	TOwnerDrawState State);
	
        void __fastcall Timer2Timer(TObject *Sender);
private:	// User declarations
public:		// User declarations
    bool securemode;
	virtual __fastcall TBackupDlg(TComponent* Owner);
	virtual __fastcall TBackupDlg(TComponent* Owner, bool SecureMode);
    bool __fastcall RestoreDatabase();
    bool __fastcall BackupDatabase();
    AnsiString __fastcall ActiveDB();
    AnsiString __fastcall ChosenDB();
    void __fastcall UpdateFileList();
};
//---------------------------------------------------------------------------
extern TBackupDlg *BackupDlg;
//---------------------------------------------------------------------------
#endif
