/*
*  HashCashM2NDlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "global.h"
#include "HashCashM2NDlgs.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
THashCashM2NDlg *HashCashM2NDlg;
//---------------------------------------------------------------------------

bool __fastcall AddHashCashM2N(TForm *Owner, AnsiString &gateway, AnsiString &resource,
   int &validity, AnsiString &dbname)
{
   HashCashM2NDlg = new THashCashM2NDlg(Owner);
   HashCashM2NDlg->GateWay->Modified = false;
   HashCashM2NDlg->Resource->Modified = false;
   HashCashM2NDlg->Validity->Modified = false;
   HashCashM2NDlg->DBName->Modified = false;
   HashCashM2NDlg->ShowModal();
   bool ok = HashCashM2NDlg->ModalResult == mrOk;
   if (ok)
   {
      gateway = HashCashM2NDlg->GateWay->Text;
      resource = HashCashM2NDlg->Resource->Text;
      validity = HashCashM2NDlg->Validity->Text.ToInt();
      dbname = HashCashM2NDlg->DBName->Text;
   }
   delete HashCashM2NDlg;
   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall ModHashCashM2N(TForm *Owner, AnsiString &gateway, AnsiString &resource,
   int &validity, AnsiString &dbname)
{
   HashCashM2NDlg = new THashCashM2NDlg(Owner);
   HashCashM2NDlg->GateWay->Text = gateway;
   HashCashM2NDlg->GateWay->ReadOnly = true;
   HashCashM2NDlg->GateWay->ParentColor = true;
   HashCashM2NDlg->GateWay->TabStop = false;
   HashCashM2NDlg->Resource->Text = resource;
   HashCashM2NDlg->Resource->Modified = false;
   HashCashM2NDlg->Validity->Text = validity;
   HashCashM2NDlg->Validity->Modified = false;
   HashCashM2NDlg->DBName->Text = dbname;
   HashCashM2NDlg->DBName->Modified = false;
   HashCashM2NDlg->ActiveControl = HashCashM2NDlg->Resource;
   HashCashM2NDlg->ShowModal();
   bool ok = HashCashM2NDlg->ModalResult == mrOk;
   if (ok)
   {
      gateway = HashCashM2NDlg->GateWay->Text;
      resource = HashCashM2NDlg->Resource->Text;
      validity = HashCashM2NDlg->Validity->Text.ToInt();
      dbname = HashCashM2NDlg->DBName->Text;
   }
   delete HashCashM2NDlg;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall THashCashM2NDlg::THashCashM2NDlg(TComponent* Owner)
        : TForm(Owner)
{
   CenterDialog(this, Owner);
}
//---------------------------------------------------------------------------

void __fastcall THashCashM2NDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult == mrOk)
   {
      if (GateWay->Text.IsEmpty() || Resource->Text.IsEmpty() || DBName->Text.IsEmpty())
      {
         MsgBoxHwnd(Handle,
            "Gateway, Resource and DBname are all required fields!",
            "Information", MB_OK);
         CanClose = false;
         return;
      }

      if (Validity->Text.ToIntDef(-1) == -1)
      {
         MsgBoxHwnd(Handle,
            "You have entered an invalid value in the Validity field.   \n"
            "It must be a numeric value greater than 0. See your token   \n"
            "minter for the exact value for this gateway.",
            "Information", MB_OK);
         CanClose = false;
         return;
      }

      if (Validity->Text.ToIntDef(-1) == 0)
      {
         MsgBoxHwnd(Handle,
            "The validity field must be greater than 0. See your token   \n"
            "minter for the exact value for this gateway.",
            "Information", MB_OK);
         CanClose = false;
      }

      if (!FileExists(DBName->Text))
      {
         if (MsgBoxHwnd(Handle,
            "The DB pathname you have specified does not exist. I can still   \n"
            "accept this if you know there will be one by the time you need   \n"
            "to use hashcash.\n\nWould you like to specify a different name?",
            "Confirm", MB_YESNO) == IDYES)
         {
            ActiveControl = DBName;
            CanClose = false;
            return;
         }
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall THashCashM2NDlg::BrowseBtnClick(TObject *Sender)
{
   if (OpenDialog1->Execute())
   {
      DBName->Text = OpenDialog1->FileName;
      DBName->Modified = true;
   }
}
//---------------------------------------------------------------------------
