/*
*  MIMEman4.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef MIMEman4H
#define MIMEman4H
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
class TMIMEdlg; class TMIMEdecoder; class TMIMEencoder;
//---------------------------------------------------------------------------
bool __fastcall HasAttached(TStrings *Message); // inbound message
bool __fastcall HasAttachments(TStrings *Message); // outbound
bool __fastcall IsMIME(TStrings *Message);

bool __fastcall IsPgpMIME(TStrings *Message);
bool __fastcall DecodePgpMIMEmessage(TStrings *Message);

AnsiString __fastcall GetCreateAttachmentDir();

class TMIMEdlg : public TForm
{
__published:	// IDE-managed Components
	TTimer *Timer1;
    TTimer *Timer2;
	TLabel *Filename;
	TButton *CancelBtn;
	TProgressBar *ProgressBar;
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall CancelBtnClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall Timer2Timer(TObject *Sender);
    private:	// User declarations
public:		// User declarations
    bool ok,*cancel;
    AnsiString AttachDir;
    TMIMEdecoder *decoder;
    TMIMEencoder *encoder;
	virtual __fastcall TMIMEdlg(TComponent* Owner);
    virtual __fastcall TMIMEdlg(TComponent *Owner, AnsiString Caption);
    int  __fastcall DecodeAttachments(TMIMEdecoder *Decoder);
    int  __fastcall EncodeAttachments(TMIMEencoder *Encoder);
};

// utilities
void __fastcall StripHTML(TStrings *part);
bool __fastcall GetAttachments(TStrings *Files, TStrings *Message);
AnsiString __fastcall dropquotes(AnsiString line);
AnsiString __fastcall GetBoundaryNumber();
AnsiString __fastcall GetBoundaryNumberEx();
AnsiString __fastcall GetPrimary(AnsiString &Field, AnsiString &Content);
AnsiString __fastcall GetPrimaryContent(TStrings *Message);
AnsiString __fastcall AddSemiColon(AnsiString &line);

// encoder status return codes
const int statNotMimeMessage = -100;
const int statMimeFileOpenError = -101;
const int statMimeOk = 0;
const int statMimeCancel = -1;
const int statMimeBadFilename = -3;
const int statMimeBadEncodeMethod = -4;
const int statMimeBadDecodeMethod = -5;
const int statMimeDecodeError = -6;

//---------------------------------------------------------------------------
extern TMIMEdlg *MIMEdlg;
//---------------------------------------------------------------------------
#endif
