/*
*  MimeDecodeDlgs.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef MimeDecodeDlgsH
#define MimeDecodeDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
//---------------------------------------------------------------------------
bool __fastcall DetachMessageAttachments(TForm *Owner);

class TMIMEmessage : public TStringList
{
public:
   __fastcall TMIMEmessage(TStrings *Message);
   __fastcall~TMIMEmessage();
   bool __fastcall HasAttachments();
   bool __fastcall GetFirstAttachment();
};

class TAttachment : public TStringList
{
   TAttachment *Attachment;
   __fastcall TAttachment();
   __fastcall~TAttachment();
   AnsiString __fastcall Boundary();
   AnsiString __fastcall SubBoundary();
   AnsiString __fastcall EncodeMethod();
   AnsiString __fastcall Filename();
   AnsiString __fastcall Header();
   AnsiString __fastcall Size();
};

class TAttachmentList : public TStringList
{
   TAttachment *Attachments;
   virtual __fastcall TAttachmentList();
   virtual __fastcall TAttachmentList(TStrings *message);
   virtual __fastcall~TAttachmentList();
   bool __fastcall getnextattachment(TStrings *message, int &pos);
};

class TMimeDecodeDlg : public TForm
{
__published:	// IDE-managed Components
	TButton *OkBtn;
	TButton *CancelBtn;
	TPanel *Panel1;
	TTreeView *TreeView1;
	TTimer *Timer1;
	void __fastcall FormShow(TObject *Sender);
	
private:	// User declarations
public:		// User declarations
	__fastcall TMimeDecodeDlg(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TMimeDecodeDlg *MimeDecodeDlg;
//---------------------------------------------------------------------------
#endif
