/*
*  MimeEncodeDlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MimeEncodeDlgs.h"
#include "HelpDlgs.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMimeNameDlg *MimeNameDlg;
//---------------------------------------------------------------------------
AnsiString __fastcall GetAttachmentFileName(TForm *Owner, AnsiString Filename)
{
   AnsiString name;
   MimeNameDlg = new TMimeNameDlg(Owner);
   MimeNameDlg->Filename->Text    = GetToken(0,Filename,",");
   MimeNameDlg->MimeBtn->Checked  = GetToken(1,Filename,",")=="base64";
   MimeNameDlg->UuBtn->Checked    = GetToken(1,Filename,",")=="x-uuencode";
   if (!MimeNameDlg->UuBtn->Checked && !MimeNameDlg->MimeBtn->Checked)
      MimeNameDlg->MimeBtn->Checked = true;
   MimeNameDlg->InlineBox->Checked = GetToken(2,Filename,",")=="body";
   //MimeNameDlg->DoNowBox->Checked  = GetToken(3,Filename,",")=="donow";
   //if (MimeNameDlg->DoNowBox->Checked)
   //{
   //   MimeNameDlg->InlineBox->Enabled = false;
   //   MimeNameDlg->InlineBox->Checked = true;
   //}
   MimeNameDlg->ShowModal();
   if (MimeNameDlg->ModalResult==mrOk)
   {
      name = MimeNameDlg->Filename->Text+","+
         (MimeNameDlg->MimeBtn->Checked ? s("base64"):s("x-uuencode"))+
         (MimeNameDlg->InlineBox->Checked ? s(",body"):s(""));
   }
   return name.LowerCase();
}
//---------------------------------------------------------------------------
__fastcall TMimeNameDlg::TMimeNameDlg(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,Owner);
   files = new TStringList();
}
//---------------------------------------------------------------------------
void __fastcall TMimeNameDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk && !FileExists(Filename->Text))
   {
      BingBox(this,"The file you have specified doesn't exist!","Filename Error",MB_OK);
      CanClose = false;
      return;
   }
   delete files;
}
//---------------------------------------------------------------------------
void __fastcall TMimeNameDlg::BrowseBtnClick(TObject *Sender)
{
   if (OpenDialog->Execute())
   {
      Filename->Text = OpenDialog->FileName;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMimeNameDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("Attachments","Sending Attachments","",AppMainForm);
}
//---------------------------------------------------------------------------
