/*
*  MixKeyWins2.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MixKeyWins2.h"
#include "MixKeyImpDlgs.h"
#include "MixProbWins2.h"
#include "BarredRemsDlgs.h"
#include "Mixmaster.h"
#include "FileWin.h"
#include "ImageMods.h"
#include "WipeDlgs.h"
#include "HelpDlgs.h"
#include "Fileman.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma link "KeyringWins"
#pragma resource "*.dfm"
TMixKeyWin2 *MixKeyWin2=NULL;
const int versLen = 9;
//---------------------------------------------------------------------------
// TMixKey
//---------------------------------------------------------------------------
__fastcall TMixKey2::TMixKey2()
  : TCustomKey()
{
}
//---------------------------------------------------------------------------
__fastcall TMixKey2::TMixKey2(TCustomKey *key)
  : TCustomKey(key)
{
}
//---------------------------------------------------------------------------
__fastcall TMixKey2::TMixKey2(TStrings *key, bool Enabled)
  : TCustomKey(key)
{
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKey2::Version()
{
   return (Count>0?GetToken(3,Strings[0]," "):s(""));
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKey2::Caps()
{
   return (Count>0?GetToken(4,Strings[0]," "):s(""));
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKey2::Create()
{
   return (Count>0?GetToken(5,Strings[0]," "):s(""));
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKey2::Expire()
{
   return (Count>0?GetToken(6,Strings[0]," "):s(""));
}
//---------------------------------------------------------------------------
// TMixKeyList
//---------------------------------------------------------------------------
__fastcall TMixKeyList2::TMixKeyList2()
   : TCustomKeyList()
{
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList2::TMixKeyList2(AnsiString filename)
   : TCustomKeyList(filename)
{
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList2::TMixKeyList2(TCustomKeyList *keys)
   : TCustomKeyList(keys)
{
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList2::TMixKeyList2(TCustomKey *key)
   : TCustomKeyList(key)
{
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList2::TMixKeyList2(TStrings *keys)
   : TCustomKeyList(keys)
{
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList2::~TMixKeyList2()
{
   delete type2;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList2::GetType2()
{
   if (!type2) type2 = new TStringList();
   MixGetType2(type2);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList2::SaveToFileBak(AnsiString &docname, int bakcopies)
{
   TMixKey2 *key;
   TStringList *newtype2 = new TStringList();
   TStringList *keys = new TStringList();
   newtype2->Sorted = true;
   for (int i=0; i<Count; i++)
   {
      key = Key(i);
      if (!key || key->Count<15) continue; //|| keys->IndexOf(key->Strings[0])>=0) continue;

      keys->Add(key->Text);
      newtype2->Add((key->enabled?"":"#")+key->Strings[0]);
   }
   ::SaveToFileBak(newtype2,mtyp2txt,bakcopies);
   ::SaveToFileBak(keys,mringtxt,bakcopies);
   modified = false;
   delete newtype2;
   delete keys;
   GetType2();
}
//---------------------------------------------------------------------------
/*void __fastcall TMixKeyList2::SaveToFileBak(AnsiString &docname, int bakcopies)
{
   TMixKey2 *key;
   TStringList *newtype2 = new TStringList();
   TStringList *keys = new TStringList();
   newtype2->Sorted = true;
   for (int i=0; i<Count; i++)
   {
      key = Key(i);
      if (!key || key->Count<15) continue; //|| keys->IndexOf(key->Strings[0])>=0) continue;

      keys->Add(key->Text);
      newtype2->Add((key->enabled?"":"#")+
         key->name+" "+key->address+" "+key->keyid+" "+key->version+" "+key->caps+" "+key->create+" "+key->expire
      );
   }
//view(newtype2,"newt2");
   ::SaveToFileBak(newtype2,mtyp2txt,bakcopies);
   ::SaveToFileBak(keys,mringtxt,bakcopies);
   modified = false;
   delete newtype2;
   delete keys;
   GetType2();
}*/
//---------------------------------------------------------------------------
TMixKey2* __fastcall TMixKeyList2::Key(int atPos)
{
   if (atPos<0 || atPos>=Count) return NULL;
   return (TMixKey2*)Objects[atPos];
}
//---------------------------------------------------------------------------
int __fastcall TMixKeyList2::AddKeys(TCustomKeyList *keys)
{
   return TCustomKeyList::AddKeys(keys);
}
//---------------------------------------------------------------------------
int __fastcall TMixKeyList2::AddKeys(TStrings *keys)
{
   int c=0;
   AnsiString desc;
   TStringList *key=new TStringList();
   TStringList *KEYS=new TStringList();
   KEYS->AddStrings(keys);
   while (MixGetNextKey(desc,key,KEYS))
   {
      AddKey(key);
      c++;
   }
   delete KEYS;
   delete key;
//view(this);
   return c;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList2::LoadFromStrings(TStrings *keys)
{
   Clear(); AddKeys(keys);
   modified = false;
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyList2::AddKey(TStrings *key)
{
   if (!MixKeyDefinately(key)) return false;
   TMixKey2 *KEY = new TMixKey2(key);
   AddKey(KEY);
   delete KEY;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyList2::AddKey(TCustomKey *key)
{
   if (!MixKeyDefinately(key)) return false;

   bool enabled;
   TMixKey2 *KEY = new TMixKey2(key);

   if (!type2) GetType2();
   if (InType2(KEY,enabled)) KEY->enabled = enabled;
   else type2->Add((KEY->enabled?"":"#")+KEY->Strings[0]);

   AnsiString desc,prm,shrt=KEY->name,addr=KEY->address;
   int i=-1; while(!(prm=GetToken(++i,KEY->Strings[0]," ")).IsEmpty())
   {
      if (i>0) desc += ",";
      desc += prm;
   }
   AddObject(desc,KEY);
   if (shrt.Length()>shrtLen) shrtLen = shrt.Length();
   if (addr.Length()>addrLen) addrLen = addr.Length();
   modified = true;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyList2::InType2(TMixKey2 *key, bool &enabled)
{
   AnsiString keydesc = key->Strings[0];
   if((enabled=type2->IndexOf("#"+keydesc)<0)==true)
      return type2->IndexOf(keydesc)>=0;
   return true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList2::KeyDescription(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   
   if (addrLen>31) addrLen = 31;
   AnsiString desc,addr;
   TStringList *flds = new TStringList();
   flds->CommaText = Strings[atPos];
   addr = PadRight(flds->Strings[1],addrLen);
   if (addr.Length()>addrLen) addr = addr.SubString(1,addrLen-3)+"...";
   int vLen,Len=flds->Strings[3].Length();
   vLen = Len>versLen?Len:versLen;

   desc = PadRight(flds->Strings[0],shrtLen)+"  "+addr+"  "+flds->Strings[2]+"  "+
      PadRight(flds->Strings[3],vLen);
   for (int f=4; f<flds->Count; f++) desc += "  "+flds->Strings[f];

   delete flds;
   return desc;
}
//---------------------------------------------------------------------------
/*AnsiString __fastcall TMixKeyList2::KeyDescription(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   if (addrLen>31) addrLen = 31;
   AnsiString desc,addr;
   TStringList *flds = new TStringList();
   flds->CommaText = Strings[atPos];

   addr = PadRight(flds->Strings[1],addrLen);
   if (addr.Length()>addrLen) addr = addr.SubString(1,addrLen-3)+"...";
   //if (addr[addrLen+1]!=' ') addr = addr.SubString(1,addrLen-3)+"...";
   int vLen,Len=flds->Strings[3].Length();
   vLen = Len>versLen?Len:versLen;
   desc = PadRight(flds->Strings[0],shrtLen)+"  "+addr+"  "+flds->Strings[2]+"  "+
      PadRight(flds->Strings[3],vLen)+"  "+flds->Strings[4];
   if (flds->Count>5) desc += "  "+flds->Strings[5];
   if (flds->Count>6) desc += "  "+flds->Strings[6];
   delete flds;
   return desc;
}*/
//---------------------------------------------------------------------------
// TMixKeyWin
//---------------------------------------------------------------------------
__fastcall TMixKeyWin2::TMixKeyWin2(TComponent* Owner)
	: TCustomKeyWin(Owner)
{

   keyringname = "Mixmaster";
   hidedisabled = GetAppIni(MixHideDisabled,"0")=="1";
   HideDisBtn->Bitmap->Assign(hidedisabled?bmpHideDis:bmpShowAll);

   CheckDeleteBarredMixmasterKeys();

   keys = new TMixKeyList2();
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
__fastcall TMixKeyWin2::TMixKeyWin2(TComponent* Owner, TMixKeyList2 *Imports)
	: TCustomKeyWin(Owner)
{
   imports = Imports;
   keyringname = "Mixmaster";
   hidedisabled = GetAppIni(MixHideDisabled,"0")=="1";
   HideDisBtn->Bitmap->Assign(hidedisabled?bmpHideDis:bmpShowAll);

   CheckDeleteBarredMixmasterKeys();

   keys = new TMixKeyList2();
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
__fastcall TMixKeyWin2::~TMixKeyWin2()
{
   CheckDeleteBarredMixmasterKeys();
   MixKeyWin2 = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin2::SaveKeys()
{
   if (!keys->Count)
   {
      if (FileExists(mringtxt)) zapfile(mringtxt,1);
      if (FileExists(mtyp2txt)) zapfile(mtyp2txt,1);
      return;
   }
   AnsiString cap = Caption;
   Caption = "Saving..."; AppProcessMessages(); Sleep(200);
   SaveBtn->Enabled = RefreshBtn->Enabled = false;
   keys->SaveToFileBak(mringtxt,STATSBAKCOPIES);
   newkeys->Clear();
   SetRedraw(TreeView,0);
   LoadTreeViewQuiet();
   AppProcessMessages();
   SetRedraw(TreeView,1);
   Caption = cap;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin2::EnableKey(int atPos, bool enable)
{
   if (atPos<0 || atPos>=keynodes->Count) return;

   TTreeNode* node = Node(atPos);
  ((TMixKey2*)node->Data)->enabled = enable;
   if (enable)
   {
      node->ImageIndex = 0; node->SelectedIndex = 0;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }
   else
   {
      node->ImageIndex = 1; node->SelectedIndex = 1;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }
   RECT r = { 0,0,50,2000 };
   InvalidateRect(TreeView->Handle,&r,false);
   keys->modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin2::LoadKeys()
{
   initdone = true;
   if (FileExists(mringtxt)) keys->LoadFromFile(mringtxt);
   if (imports && imports->Count) AddKeysImport(imports);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin2::LoadTreeView()
{
   TTreeNode *node,*cnode;
   ClearTree();
   TStringList *next=new TStringList();
   TreeView->Items->BeginUpdate();
   for (int i=0; i<keys->Count; i++)
   {
      TMixKey2 *KEY = ((TMixKeyList2*)keys)->Key(i);
      if (newkeys->IndexOf(keys->Strings[i])<0 && hidedisabled && !KEY->enabled) continue;

      AnsiString keydesc = keys->KeyDescription(i);
//if (keydesc.Pos("dismix ")==1) sm(keydesc+"\nx"+GetParam(4,keydesc," ")+"x");
      node = TreeView->Items->AddChildObject(TreeView->Selected,keydesc,KEY);

      node->ImageIndex = KEY->enabled ? 0:1;
      node->SelectedIndex = node->ImageIndex;

      if (newkeys->IndexOf(keys->Strings[i])>=0) SetTreeItemBold(node,true,TreeView);
      keynodes->Add(node);

      AnsiString prm,caps;
      keydesc = KEY->Strings[0];
      /*int p=-1; while(!(prm=GetToken(++p,keydesc," ")).IsEmpty())
      {
         cnode=TreeView->Items->AddChild(node,"Name    : "+prm);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      }*/
      cnode=TreeView->Items->AddChild(node,"Name    : "+GetParam(0,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Address : "+GetParam(1,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Key-Id  : "+GetParam(2,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Version : "+GetParam(3,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Caps    : "+GetParam(4,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      AnsiString create = GetParam(5,keydesc," ");
      if (!create.IsEmpty())
      {
         cnode=TreeView->Items->AddChild(node,"Created : "+create);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      }
      AnsiString expire = GetParam(6,keydesc," ");
      if (!expire.IsEmpty())
      {
         cnode=TreeView->Items->AddChild(node,"Expires : "+expire);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      }
   }
   TreeView->Items->EndUpdate();
   RECT r = { 0,0,4096,4096 };
   InvalidateRect(TreeView->Handle,&r,false);
   AppProcessMessages();
   delete next;
}
//---------------------------------------------------------------------------
/*void __fastcall TMixKeyWin2::LoadTreeView()
{
   TTreeNode *node,*cnode;
   ClearTree();
   TStringList *next=new TStringList();
   TreeView->Items->BeginUpdate();
   for (int i=0; i<keys->Count; i++)
   {
      TMixKey2 *KEY = ((TMixKeyList2*)keys)->Key(i);
      if (newkeys->IndexOf(keys->Strings[i])<0 && hidedisabled && !KEY->enabled) continue;

      AnsiString keydesc = keys->KeyDescription(i);
//if (keydesc.Pos("dismix ")==1) sm(keydesc+"\nx"+GetParam(4,keydesc," ")+"x");
      node = TreeView->Items->AddChildObject(TreeView->Selected,keydesc,KEY);

      node->ImageIndex = KEY->enabled ? 0:1;
      node->SelectedIndex = node->ImageIndex;

      if (newkeys->IndexOf(keys->Strings[i])>=0) SetTreeItemBold(node,true,TreeView);
      keynodes->Add(node);

      keydesc = KEY->Strings[0];
      cnode=TreeView->Items->AddChild(node,"Name    : "+GetParam(0,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Address : "+GetParam(1,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Key-Id  : "+GetParam(2,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Version : "+GetParam(3,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Caps    : "+GetParam(4,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      AnsiString create = GetParam(5,keydesc," ");
      if (!create.IsEmpty())
      {
         cnode=TreeView->Items->AddChild(node,"Caps    : "+create);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      }
      AnsiString expire = GetParam(6,keydesc," ");
      if (!expire.IsEmpty())
      {
         cnode=TreeView->Items->AddChild(node,"Caps    : "+expire);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      }
   }
   TreeView->Items->EndUpdate();
   RECT r = { 0,0,4096,4096 };
   InvalidateRect(TreeView->Handle,&r,false);
   AppProcessMessages();
   delete next;
}*/
//---------------------------------------------------------------------------

TMixKey2* __fastcall TMixKeyWin2::NodeKey(int atPos)
{
   if (atPos<0 || atPos>=keynodes->Count) return NULL;
   TMixKey2 *key = (TMixKey2*)((TTreeNode*)keynodes->Items[atPos])->Data;
   return key;
}
//---------------------------------------------------------------------------

void __fastcall TMixKeyWin2::AddKeysImport(TCustomKeyList *NewKeys)
{
   while (!initdone) AppProcessMessages(); // may not be init yet
   newkeys->Text = NewKeys->Text;
   keys->AddKeys(NewKeys);
   ClearAllBtn->Enabled = keys->Count>0 ? true:false;
   SaveBtn->Enabled = RefreshBtn->Enabled = true;
   LoadTreeView();
   SetNothingSelected();
   AppProcessMessages();
}
//---------------------------------------------------------------------------

void __fastcall TMixKeyWin2::ImportBtnClick(TObject *Sender)
{
   AnsiString ImportDir,orgDir;
   TMixKeyList2 *impkeys = new TMixKeyList2();
   TMixKeyList2 *dupkeys = new TMixKeyList2();
   ImportDir = orgDir = GetAppIni(MixImportDir,MixDir());
   if (ImportMixmasterKeys(this,(TMixKeyList2*)keys,impkeys,dupkeys,ImportDir))
   {
      if (impkeys->Count)
      {
         Sleep(100);
         BringToFront();
         AppProcessMessages();
         AddKeysImport(impkeys);
      }
      if (dupkeys->Count && this==MixKeyWin2)
      {
         if (!MixProbWin2) MixProbWin2 = new TMixProbWin2(AppMainForm);//,false);
         MixProbWin2->BringToFront(); AppProcessMessages();
         MixProbWin2->AddKeysImport(dupkeys);
      }
   }
   if (ImportDir!=orgDir)
      PutAppIni(MixImportDir,ImportDir);
   delete dupkeys;
   delete impkeys;
}
//---------------------------------------------------------------------------

void __fastcall TMixKeyWin2::RemailerDocItemClick(TObject *Sender)
{
   AnsiString doc; int d;
   TMenuItem *item = dynamic_cast<TMenuItem*>(Sender);
   if (item)
   {
      doc = MixDir()+item->Caption;
      while ((d=doc.Pos("&"))>0) doc.Delete(d,1);
      if (FileExists(doc)) EditTextFile(doc);
   }
}
//---------------------------------------------------------------------------

bool __fastcall TMixKeyWin2::DupleRemailers()
{
   AnsiString name,names=",";
   TStringList *rems = new TStringList();
   for (int i=0; i<keys->Count; i++)
   {
      TMixKey2 *KEY = ((TMixKeyList2*)keys)->Key(i);
      if (KEY->enabled)
      {
         if (names.Pos(","+KEY->name+",")==0) names += KEY->name+",";
         else
         {
            MsgDlg(AppMainForm,
               s("I've encountered a problem. You have 2 separate keys enabled for\n")+
               s("the remailer '"+KEY->name+"'. Please have a look and determine which key should\n")+
               s("be enabled and disable the other. If this cannot be discerned, disable\n")+
               s("both until verifying information is available."),
               s("Duplicate Key Error"),
               MB_OK);
            if (hidedisabled) HideDisBtn->Click();
            delete rems;
            return true;
         }
      }
   }
   delete rems;
   return false;
}
//---------------------------------------------------------------------------

void __fastcall TMixKeyWin2::HelpBtnClick(TObject *Sender)
{
   OpenHelp(
      "MixmasterKeys\nMixmasterKeysImp\nMixmasterKeysDup\nMixmasterCaps\nRemailerConfig",
      "Mixmaster Key Manager",
      "Mixmaster Keyring Manager"
   );
}
//---------------------------------------------------------------------------

void __fastcall TMixKeyWin2::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (DupleRemailers())
   {
      CanClose = false;
      return;
   }
   TCustomKeyWin::FormCloseQuery(Sender,CanClose);
}
//---------------------------------------------------------------------------

void __fastcall TMixKeyWin2::BarrBtnClick(TObject *Sender)
{
   EditBarredMixmasterRemailers(AppMainForm);
}
//---------------------------------------------------------------------------

void __fastcall TMixKeyWin2::PopupMenu2Popup(TObject *Sender)
{
   mlisttxt1->Enabled = FileExists(mlisttxt);
   type2list1->Enabled = FileExists(mtyp2txt);
   pubringmix1->Enabled = FileExists(mringtxt);
}
//---------------------------------------------------------------------------

void __fastcall TMixKeyWin2::PopupMenuPopup(TObject *Sender)
{
   bool hassel = TreeView->Selected!=NULL;
   PopBarRemailerItem->Enabled = hassel;
   PopBarRemailerLastItem->Enabled = hassel;
   PopDisableItem->Enabled = hassel;
   PopDeleteItem->Enabled = hassel;
}
//---------------------------------------------------------------------------

void __fastcall TMixKeyWin2::PopBarRemailerItemClick(TObject *Sender)
{
   assert(TreeView->Selected != NULL);
   AnsiString barrem = GetToken(0, TreeView->Selected->Text, " ");

   if (MsgDlg(AppMainForm,
      "Bar the " + barrem + " remailer? ",
      "Confirm",MB_OKCANCEL) == IDOK)
   {
      TStringList *bars = new TStringList();
      bars->Duplicates = dupIgnore;
      bars->Sorted = true;

      if (FileExists(BarFile))
         bars->LoadFromFile(BarFile);

      bars->Add(barrem);
      bars->SaveToFile(BarFile);

      MsgDlg(AppMainForm,
         "The remailer, " + barrem + ", has been added to the  \n"
         "barred remailer list. The key will be removed\n"
         "when you close the keyring window.",
         "Information",
         MB_OK
      );
   }
}
//---------------------------------------------------------------------------

void __fastcall TMixKeyWin2::PopBarRemailerLastItemClick(TObject *Sender)
{
   assert(TreeView->Selected != NULL);
   AnsiString barrem = GetToken(0, TreeView->Selected->Text, " ");

   if (MsgDlg(AppMainForm,
      "Bar the " + barrem + " remailer from last in chain? ",
      "Confirm",MB_OKCANCEL) == IDOK)
   {
      TStringList *bars = new TStringList();
      bars->Duplicates = dupIgnore;
      bars->Sorted = true;

      if (FileExists(BarFile))
         bars->LoadFromFile(BarFile);

      bars->Add(barrem + ",last");
      bars->SaveToFile(BarFile);

      MsgDlg(AppMainForm,
         "The remailer, " + barrem + ", has been added to the    \n"
         "barred remailer list. It will be marked middleman     \n"
         "when you close the keyring window.",
         "Information",
         MB_OK
      );
   }
}
//---------------------------------------------------------------------------
