/*
*  NymDecDlgs2.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Global.h"
#include "Fileman.h"
#include "NymDecDlgs2.h"
#include "Mixmaster.h"
#include "pgpfiles.h"
#include "pgpmail.h"
#include "pgpbuffers.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TNymDecDlg2 *NymDecDlg2;
//---------------------------------------------------------------------------

int __fastcall DecryptNymMessage2(TForm *Owner, TStrings *message)
{
   TStringList *msg = new TStringList();
   msg->AddStrings(message);

   TNymDecDlg2 *NymDecDlg2 = new TNymDecDlg2(Owner);
   if (NymDecDlg2->Decrypt(msg))
   {
      message->Clear();
      message->AddStrings(msg);
   }

   int errorcode = NymDecDlg2->errorcode;
   delete NymDecDlg2;

   delete msg;
   return errorcode;
}

//---------------------------------------------------------------------------
// NymDecDlg2
//---------------------------------------------------------------------------

__fastcall TNymDecDlg2::TNymDecDlg2(TComponent* Owner)
        : TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner);
}
//---------------------------------------------------------------------------

void __fastcall TNymDecDlg2::FormShow(TObject *Sender)
{
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------

__fastcall TNymDecDlg2::~TNymDecDlg2()
{
   delete nyms;
}
//---------------------------------------------------------------------------

void __fastcall TNymDecDlg2::LoadPasswords()
{

   bool saving;
   nyms = new TStringList();
   nyms->Duplicates = dupIgnore;
   AnsiString nym,line,key,enckey;
   TStringList *words = new TStringList();
   TStringList *profile = new TStringList();
   TStringList *nymdat = new TStringList();
   TStringList *thenyms = new TStringList();
   int last;

   GetAppData(thenyms, "Nyms2");
   for (int i = 0; i < thenyms->Count; i++)
   {
      GetAppData(nymdat, "Nyms2" + PS + thenyms->Strings[i]);
      saving = false;
      profile->Clear();

      last = -1;
      for (int z = 0; z < 3; z++)
      {
         for (int x = last + 1; x < nymdat->Count; x++)
         {
            line = nymdat->Strings[x].Trim();

            if (line.IsEmpty())
               continue;

            if (line.Pos("Reply-Block:") == 1)
               saving = true;

            if (line.Pos("Public Key:") == 1)
            {
               last = x;
               break;
            }

            if (saving)
               profile->Add(line);
         }

         if (profile->Count == 0)
            continue;

         profile->Insert(0, "");

         for (int p = profile->Count - 1; p > 0; p--)
         {
            line = profile->Strings[p];

            if (line.Pos("Reply-Block:") == 1)
            {
               AnsiString wordstr = words->CommaText;
               if (!wordstr.IsEmpty() && nyms->IndexOf(wordstr) < 0)
                  nyms->Add(wordstr);
               words->Clear();
               continue;
            }

            if (line.Pos("Encrypt-Key: ") == 1)
            {
               words->Add(line.SubString(line.Pos(" ") + 1, 256));
               continue;
            }

            if (line.Pos("Encrypt-3DES: ") == 1)
            {
               words->Add(line.SubString(line.Pos(" ") + 1, 256));
               continue;
            }

            if (line.Pos("Encrypt-CAST: ") == 1)
            {
               words->Add(line.SubString(line.Pos(" ") + 1, 256));
               continue;
            }
         }
      }
   }

   delete words;
   delete thenyms;
   delete profile;
   delete nymdat;
}
//---------------------------------------------------------------------------

bool __fastcall TNymDecDlg2::Decrypt(TStrings *Msg)
{
   msg = Msg; ShowModal();
   return success;
}
//---------------------------------------------------------------------------

bool __fastcall TNymDecDlg2::PGPDecryptConventional(TStrings *msg, AnsiString &password)
{
   BUFFER *MSG = buf_new(); BUFFER *PAS = buf_new();
   MSG->sensitive = true; PAS->sensitive = true;

   int idx;
   buf_appends(PAS, password.c_str());
   buf_appends(MSG, msg->Text.c_str());

   errorcode = pgp_decrypt(MSG, PAS, NULL, NULL, NULL);
   if (errorcode == PGP_OK)
   {
      msg->SetText((char*)MSG->data);
      if ((idx=msg->IndexOf(BeginPgpMessage))>=0)
      {
         for (int i=0; i<idx; i++)
            if (msg->Count) msg->Delete(0);
      }

      if ((idx=msg->IndexOf(EndPgpMessage))>=0)
      {
         while (msg->Count>idx)
            msg->Delete(msg->Count-1);
      }
   }

   buf_free(PAS);
   buf_free(MSG);

   return errorcode == PGP_OK;
}
//---------------------------------------------------------------------------

/*void __fastcall TNymDecDlg2::UpdateCaption(AnsiString &updateinfo)
{
   // not used
   Panel1->Caption = ""; AppProcessMessages(); Sleep(100);
   Panel1->Caption = updateinfo;
   AppProcessMessages();
   Sleep(400);
}*/
//---------------------------------------------------------------------------

bool __fastcall TNymDecDlg2::PGPIsConventional(TStrings *Msg)
{
   return ::PgpIsConventional(Msg->Text.c_str());
}
//---------------------------------------------------------------------------

void __fastcall TNymDecDlg2::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   Snooze(10);

   LoadPasswords();

   AnsiString errlog = MixDir()+"errlog";
   TStringList *ErrLog = new TStringList();

   if (FileExists(errlog))
      ErrLog->LoadFromFile(errlog);

   success = false;

   TStringList *words = new TStringList();
   for (int n = 0; n < nyms->Count; n++) //int n = 0; while(n < nyms->Count)
   {
      words->CommaText = nyms->Strings[n];
      for (int w = 0; w < words->Count; w++)
      {
         if (PGPDecryptConventional(msg, words->Strings[w]))
         {
            if (msg->IndexOf(BeginPgpMessage) < 0 || !PGPIsConventional(msg))
            {
               success = true;
               break;
            }
            continue;
         }
         break;
      }

      if (success)
         break;
   }
   delete words;

   if (success)
      ErrLog->SaveToFile(errlog);

   ModalResult = mrOk;
}
//---------------------------------------------------------------------------

/*void __fastcall TNymDecDlg2::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   Snooze(10);

   LoadPasswords();
   //Snooze(300);

   AnsiString phrase;
   AnsiString errlog = MixDir()+"errlog";
   TStringList *ErrLog = new TStringList();

   if (FileExists(errlog))
      ErrLog->LoadFromFile(errlog);

   success = false;

   int n = 0; while(n < nyms->Count)
   {
      AnsiString words = nyms->Strings[n];
sm(words);
      int p = 0; while((phrase = GetToken(p, nyms->Strings[n], ",")) != "")
      {
         if (PGPDecryptConventional(msg, phrase))
         {
            if (msg->IndexOf(BeginPgpMessage) < 0 || !PGPIsConventional(msg))
            {
               success = true;
               break;
            }
            p++;
            continue;
         }
         n++;
      }

      if (success)
         break;

      n++;
   }

   if (success)
      ErrLog->SaveToFile(errlog);

   ModalResult = mrOk;
}*/
//---------------------------------------------------------------------------
