/*
*  SmtpDlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <filectrl.hpp>
#include <time.h>
#pragma hdrstop

#include "SmtpDlgs.h"
#include "RemailerDlgs.h"
#include "MixKeyWins2.h"
#include "MailboxWins.h"
#include "MailboxDlgs.h"
#include "Mail2DiskDlgs.h"
#include "Mail2ExplDlgs.h"
#include "SMTPAuthDlgs.h"
#include "MsgTooBigDlgs.h"
#include "MsgWins.h"
#include "Mixmaster.h"
#include "PrintDlgs.h"
#include "nymmail.h"
#include "WipeDlgs.h"
#include "PgpMail.h"
#include "PgpFiles.h"
#include "HeadMan.h"
#include "MIMEman4.h"
#include "MIMEmanEnc.h"
#include "HelpDlgs.h"
#include "FileMan.h"
#include "ProThrd.h"
#include "Global.h"
#include "Pool.h"
#include "view.h"

#pragma link "SmtpProt"
#pragma resource "*.dfm"
TSmtpDlg *SmtpDlg;
//---------------------------------------------------------------------------

bool __fastcall GetNewRemailerStats(TForm *Owner, const AnsiString &statsapp)
{
   AnsiString msg;
   HANDLE handle = Exec95(statsapp + " -auto");

   DWORD rc = WAIT_TIMEOUT;
   StatsUpdateComplete = false;
   while (rc == WAIT_TIMEOUT && !StatsUpdateComplete && !Application->Terminated)
   {
      rc = WaitForSingleObject(handle, 300);

      if (msg.IsEmpty()) msg = "Waiting stats update...";
      else msg = "";

      PostMessage(Application->MainForm->Handle, WM_SHOWSTATUS, 0, (LPARAM)msg.c_str());
      Application->ProcessMessages();
   };

   PostMessage(Application->MainForm->Handle, WM_SHOWSTATUS, 0, (LPARAM)"");

   if (StatsUpdateComplete == StatsUpdateCancel)
      return false;

   return true;
}
//---------------------------------------------------------------------------

bool __fastcall SendMail(bool AndClose)
{
   if (UpdateStatsOnSend())
   {
      bool gotstats = false;
      AnsiString newstats = AppDir + "QSstats.exe";

      if (FileExists(newstats))
      {
          if (!GetNewRemailerStats(AppMainForm, newstats))
             return false;

          gotstats = true;
      }

      if (!gotstats)
      {
         if (!GetRemailerStats(AppMainForm, false))
         {
            return false;
         }
      }

      Application->ProcessMessages();
      Sleep(500);
   }

   SmtpDlg = new TSmtpDlg(Application->MainForm);
   SmtpDlg->AndClose = AndClose;
   bool ok = SmtpDlg->Execute();
   delete SmtpDlg;

   if (!AppDataExists(MailQueue)) SetQueueHasChainMail(false);

   if (AndClose)
   {
      Application->MainForm->Close();
   }

   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall UpdateStatsOnSend()
{
   return AppMainForm->Perform(WM_UPDATECHECKED,0,NULL)>0;
}
//---------------------------------------------------------------------------
void __fastcall SetQueueHasChainMail(bool state)
{
   PutAppIni(QueueHasChain,(state==true?"1":"0"));
}
//---------------------------------------------------------------------------

bool __fastcall QueueHasChainMail()
{
   return GetAppIni(QueueHasChain,"0")=="1";
}
//---------------------------------------------------------------------------

bool __fastcall WrapMessage(TStrings *Message, int AtCol)
{
   AnsiString line;
   AnsiString qm = GetAppIni(QuoteMarks,"> ");
   bool notquoted = GetAppIni(DontWrapQuoted,"").ToIntDef(0);

   if (AtCol == -1)
   {
      AtCol = 0;
      line = Message->Strings[0];
      if (line.Pos(WordWrapHeader) == 1)
      {
         AtCol = line.SubString(WordWrapHeader.Length()+1,16).ToIntDef(0);
         Message->Delete(0);
      }
   }

   bool inhead = true;
   AnsiString msgstr = Message->Text;
   TStringList *mail = new TStringList();

   while (Message->Count)
   {
      int col = AtCol;

      line = Message->Strings[0].TrimRight();
      if (inhead)
      {
         if (line.IsEmpty())
            inhead = false;

         mail->Add(line);
         if (Message->Count < 2)
         {
          //assert(Message->Count > 1);
            MsgBoxHwnd(Application->MainForm->Handle,
               "It appears you message does not have an empty line between the headers and body   \n"
               "I'm stopping the send. Please take a look.",
               "Information",
                MB_OK);
            Message->Text = msgstr;
            delete mail;
            return false;
         }
         if (!inhead && Message->Strings[1] == "##")
            inhead = true;
      }
      else
      {
         if (line.Pos(qm)==1 && notquoted) col = 0;
         AddString(line, mail, col);
      }

      Message->Delete(0);
   }

   Message->Text = mail->Text;
   delete mail;
   return true;
}
//---------------------------------------------------------------------------
/*void __fastcall WrapMessage(TStrings *Message, int AtCol)
{
   AnsiString line;
   AnsiString qm = GetAppIni(QuoteMarks,"> ");
   bool notquoted = GetAppIni(DontWrapQuoted,"").ToIntDef(0);

   if (AtCol==-1)
   {
      AtCol = 0;
      line = Message->Strings[0];
      if (line.Pos(WordWrapHeader)==1)
      {

         AtCol = line.SubString(WordWrapHeader.Length()+1,16).ToIntDef(0);
         Message->Delete(0);
      }
   }
   bool inhead = true;
   TStringList *mail = new TStringList();
   while (Message->Count)
   {
      int col=AtCol;
      line = Message->Strings[0].TrimRight();
      if (inhead)
      {
         if (line.IsEmpty()) inhead = false;
         mail->Add(line);
      }
      else
      {
         if (line.Pos(qm)==1 && notquoted) col = 0;
         AddString(line,mail,col);
      }
      Message->Delete(0);
   }
   Message->Text = mail->Text;
   delete mail;
}*/
//---------------------------------------------------------------------------
void __fastcall AddString(AnsiString &String, TStrings *Strings, int WordWrapAt)
{
   AnsiString s=String;
   int wwAt=WordWrapAt,wwActual=wwAt-1;
   if (wwAt>0 && wwAt<16) wwAt = 16;
   while (wwAt>0 && s.Length()>wwAt)
   {
      for (int i=wwAt; i>0; i--)
         if (s[i]==' ' || s[i]=='-')
         {
            wwActual = i; break;
         }
      Strings->Add(s.SubString(1,wwActual));
      s = s.SubString(wwActual+1,4096);
   }
   Strings->Add(s);
}
//---------------------------------------------------------------------------
AnsiString __fastcall SMTPPOP3logtime()
{
   return FormatDateTime("mmm dd, yyyy hh:nn:ss (ddd)",Now());
}
//---------------------------------------------------------------------------
void __fastcall OpenMail2DiskDirectory(TForm *Owner, AnsiString &Directory)
{
   if (ExplainExplorerDetails(Owner,Directory))
      ExploreFolder(Directory);
}
//---------------------------------------------------------------------------
#define DISPLAY(msg) Display->Lines->Add(msg)
__fastcall TSmtpDlg::TSmtpDlg(TComponent* Owner)
	: TForm(Owner)
{
   // Center in Main Window
   TForm *Main = Application->MainForm;
   Top = Main->Top+((Main->Height-Height)/2);
   Left = Main->Left+((Main->Width-Width)/2);
   Panel2->Align = alClient;
   Display->Clear();
   // initialize
   Application->OnException = ExceptionHandler;
   MixPoolDeleteFile();

   Messages = new TStringList();
   Messages->Sorted = true;
   GetAppData(Messages,MailQueue);
   Messages->Sorted = false;
   //if (!Messages->Count) return; // nothing to send...

   Head = new TStringList();
   Body = new TStringList();
   Message = new TStringList();
   specialheaders = new TStringList();

   bak = new TStringList();
   ProblemRpt = new TStringList();
   LastMixFeedback = new TStringList();
   NymConfigNym = "";
   NymLogEntry = "";
   Cancelled = false;
   Aborted = false;
   InEHLO = false;

   LastError = 0;
   //MimeMan = NULL;
   MixMan = NULL;
   Rset = false;
   curmsg = 0;
}
//---------------------------------------------------------------------------
__fastcall TSmtpDlg::~TSmtpDlg()
{
   MixPoolDeleteFile();
   delete LastMixFeedback;
   delete ProblemRpt;
   delete bak;
   delete Head;
   delete Body;
   delete specialheaders;
   delete Message;
   delete Messages;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::FormShow(TObject *Sender)
{
   Cancelled = false;
   PostMessage(Handle,WM_NEXTMESSAGE,0,0L);
}
//---------------------------------------------------------------------------
int __fastcall TSmtpDlg::Execute()
{
   ShowModal(); return ModalResult;
}
//---------------------------------------------------------------------------

int __fastcall TSmtpDlg::GetHeaders()
{
   int count=0;
   Head->Clear();
   Body->Clear();
   bool inhead=true;
   if (Message!=NULL)
   {
      for (int i=0; i<Message->Count; i++)
      {
         AnsiString s = Message->Strings[i];
         if (s.IsEmpty() && inhead) inhead = false;
         else if (!inhead) Body->Add(s);
         else Head->Add(s);
      }
      TrimNullsAfter(Body);
      Body->Add("");
   }

   return count;
}
//---------------------------------------------------------------------------
void __fastcall AddDateHeader(TStrings *toHeaders)
{
   bool hasdate = false;
   int pos=0; while(pos<toHeaders->Count)
   {
      AnsiString hdr = toHeaders->Strings[pos];
      if (hdr.Trim().IsEmpty())
         break;

      if (hdr.Pos("Date:")==1)
      {
         hasdate = true;
         break;
      }
      pos++;
   }
   if (!hasdate)
      toHeaders->Insert(pos,"Date: "+Rfc822DateTime(Now()));
}
//---------------------------------------------------------------------------

bool __fastcall IsNymConfigMessage(TStrings *Message, AnsiString &nym)
{
   AnsiString line, ToAddr, name, server;

   TStringList *nymservers = new TStringList();

   if (FileExists(AppDir + "qsnym.exe"))
   {
      if (FileExists(AppDir + "nymserver.asc"))
         nymservers->LoadFromFile(AppDir + "nymserver.asc");

      int i = 0; while(i < nymservers->Count)
      {
         AnsiString line = nymservers->Strings[i].Trim();

         if (line.Pos("$nymserver{") == 1)
         {
            nymservers->Strings[i] = GetToken(1, GetToken(0, line, ">"), "@");
         }
         else
         {
            nymservers->Delete(i);
            continue;
         }

         i++;
      }
   }
   else
   {
      GetAppData(nymservers, NymServersKey);
   }

   nym = "";
   for (int i=0; i<Message->Count; i++)
   {
      line = Message->Strings[i];
      if (line.Pos("To: ")==1)
      {
         ToAddr = line.SubString(5,256);
         for (int s=0; s<nymservers->Count; s++)
         {
            if ("config@"+nymservers->Strings[s]==ToAddr)
            {
               server = nymservers->Strings[s];
               break;
            }
         }
         break;
      }
   }
   delete nymservers;

   if (server.IsEmpty())
      return false;

   int f = 0;
   for (int i = 0; i < Message->Count; i++)
   {
      line = Message->Strings[i];
      if (line.Pos("From: ")==1)
      {
         f++;
         if (f == 2)
         {
            name = line.SubString(7, 256);
            break;
         }
      }
   }

   if (name.IsEmpty())
      return false;

   nym = name + "@" + server;
   return true;
}
//---------------------------------------------------------------------------

AnsiString __fastcall SocksVer4Sure(const AnsiString &socksver)
{
   AnsiString ver = "4";
   if (socksver.LowerCase() == "4a" ||  socksver == "5")
      ver = socksver;
   return ver;
}
//---------------------------------------------------------------------------

/*void __fastcall TSmtpDlg::SetSessionProxy(const AnsiString &name)
{
   TStringList *proxy = new TStringList();
   TStringList *proxies = new TStringList();
   GetAppData(proxies, "proxies");
   for (int i = 0; i < proxies->Count; i++)
   {
      AnsiString line = proxies->Strings[i];
      if (GetToken(0, line, ",") == name && GetToken(4, line, ",") != " ")
      {
         GetAppData(proxy, "proxies" + PS + line);
         SMTP->CtrlSocket->SocksServer = proxy->Values["host"];
         SMTP->CtrlSocket->SocksPort = proxy->Values["smtpport"];
         AnsiString socksver = proxy->Values["socksver"];
         if (socksver != "")
            SMTP->CtrlSocket->SocksLevel = socksver;
         if (proxy->Values["auth"] == "1")
         {
            SMTP->CtrlSocket->SocksPassword = proxy->Values["password"];
            SMTP->CtrlSocket->SocksUsercode = proxy->Values["userid"];
         }
         if (proxy->Values["tor"] == 1)
            SMTP->SignOn = "nowhere.invalid"; //proxy->Values["torsignon"];
         break;
      }
   }
   delete proxies;
   delete proxy;
}*/
//---------------------------------------------------------------------------

bool __fastcall TSmtpDlg::PrepareMail()
{
   AnsiString SignOn, FName, Host, Port;
   for (int i = 0; i < specialheaders->Count; i++)
   {
      Message->Insert(i, specialheaders->Strings[i]);
   }

   GetHeaders();   // before this Head is empty
   THeaderManager *hm = new THeaderManager(Head);

   SMTP->CtrlSocket->SocksServer = "";
   SMTP->CtrlSocket->SocksPort = "";
   SMTP->CtrlSocket->SocksLevel = "4a";
   SMTP->CtrlSocket->SocksUsercode = "";
   SMTP->CtrlSocket->SocksPassword = "";
   SMTP->CtrlSocket->SocksAuthentication = socksNoAuthentication;
   SMTP->SignOn = "";

   proxyname = hm->GetDat("Proxy: ");
   if (proxyname.IsEmpty())
      proxyname = "<none>";

   if (!proxyname.IsEmpty() && proxyname != "<none>")
   {
      TStringList *proxy = new TStringList();
      GetAppData(proxy, "proxies" + PS + proxyname);
      if (proxy->Count == 0)
      {
         MsgBoxHwnd(Handle,
            "The proxy you have been using, '" + GetToken(0, proxyname, ",") + "', has been deleted!    ",
            "Warning", MB_OK);
         delete proxy;
         delete hm;
         return false;
      }

//name=TOR
//host=127.0.0.1
//socksver=4a
//smtp=1
//smtpport=9050
//tor=1
//torsignon=nowhere.invalid
//auth=0
//hidetyping=0

      SMTP->CtrlSocket->SocksServer = proxy->Values["host"];
      SMTP->CtrlSocket->SocksPort = proxy->Values["smtpport"];
      SMTP->CtrlSocket->SocksLevel = SocksVer4Sure(proxy->Values["socksver"]);

      if (proxy->Values["auth"] == "1")
      {
         SMTP->CtrlSocket->SocksPassword = proxy->Values["password"];
         SMTP->CtrlSocket->SocksUsercode = proxy->Values["userid"];
         SMTP->CtrlSocket->SocksAuthentication = socksAuthenticateUsercode;
      }

      if (proxy->Values["tor"] == 1)
         SMTP->SignOn = "nowhere.invalid";

      delete proxy;
   }

   BytesSent = 0;
   ProgressBar->Position = 0;
   BytesTotal = Body->Text.Length();
   Snooze(200);
   Host = hm->GetDat("Host: ");
   if (Host.Pos(":")>1)
   {
      Port = GetParam(1, Host, ":");
      Host = GetParam(0, Host, ":");
   }

   SMTP->Port = 25;
   SMTP->Host = Host;
   if (!Port.IsEmpty()) SMTP->Port = Port;
   FName = hm->GetDat("From: ");
   SMTP->FromName = hm->GetAddress(FName);

   if (SMTP->SignOn.IsEmpty())
   {
      if ((SignOn = hm->GetDat("Sign-On: ")).IsEmpty())
         SignOn = hm->GetDomain(SMTP->FromName);
      SMTP->SignOn = SignOn;
   }
   SMTP->HdrFrom = FName;

   SMTP->HdrSubject = hm->GetDat("Subject: ");
   SMTP->HdrTo = hm->GetDat("To: ");
   hm->GetAttachments(SMTP->EmailFiles);
   hm->GetRecipients(SMTP->RcptName);
   if (ADDDATEHEADER)
      AddDateHeader(Head);

   AnsiString userid, passwd;
   SMTP->AuthType = smtpAuthNone;
   if (NeedsSMTPAuthentication(SMTP->Host, userid, passwd))
   {
    //sm(userid+"\n"+passwd);
      SMTP->Username = userid;
      SMTP->Password = passwd;
      SMTP->AuthType = smtpAuthCramMD5; // set as a flag that auth required, may select another protocol in onresponse
   }

   hm->Delete("Sign-On: ");
   hm->Delete("Proxy: ");
   hm->Delete("Tor: ");
   hm->Delete("Socks: ");
   hm->Delete("Sent: ");
   hm->Delete("Host: ");
   hm->Delete("Bcc: ");
   hm->Delete("Fcc: ");
   delete hm;

   return true;
}
//---------------------------------------------------------------------------

/*bool __fastcall TSmtpDlg::PrepareMail()
{
   AnsiString SignOn, FName, Host, Port, proxy;
   for (int i = 0; i < specialheaders->Count; i++)
   {
      Message->Insert(i, specialheaders->Strings[i]);
   }

   GetHeaders();   // before this Head is empty

   SMTP->CtrlSocket->SocksServer = "";
   SMTP->CtrlSocket->SocksPort = "";
   SMTP->CtrlSocket->SocksLevel = "4a";
   SMTP->CtrlSocket->SocksUsercode = "";
   SMTP->CtrlSocket->SocksPassword = "";
   SMTP->SignOn = "";

   proxy = HeadMan->GetDat("Proxy: ", Head);
   if (!proxy.IsEmpty())
   {
      SetSessionProxy(proxy);
   }

   BytesSent = 0;
   ProgressBar->Position = 0;
   BytesTotal = Body->Text.Length();
   Snooze(200);
   Host = HeadMan->GetDat("Host: ", Head);
   if (Host.Pos(":")>1)
   {
      Port = GetParam(1,Host,":");
      Host = GetParam(0,Host,":");
   }

   SMTP->Port = 25;
   SMTP->Host = Host;
   if (!Port.IsEmpty()) SMTP->Port = Port;
   FName = HeadMan->GetDat("From: ");
   SMTP->FromName = HeadMan->GetAddress(FName);

   if (SMTP->SignOn.IsEmpty())
   {
      if ((SignOn = HeadMan->GetDat("Sign-On: ", Head)).IsEmpty())
         SignOn = HeadMan->GetDomain(SMTP->FromName);
      SMTP->SignOn = SignOn;
   }
   SMTP->HdrFrom = FName;

   SMTP->HdrSubject = HeadMan->GetDat("Subject: ");
   SMTP->HdrTo = HeadMan->GetDat("To: ");
   HeadMan->GetAttachments(SMTP->EmailFiles);
   HeadMan->GetRecipients(SMTP->RcptName);
   if (ADDDATEHEADER)
      AddDateHeader(Head);

   AnsiString userid, passwd;
   SMTP->AuthType = smtpAuthNone;
   if (NeedsSMTPAuthentication(SMTP->Host, userid, passwd))
   {
      SMTP->Username = userid;
      SMTP->Password = passwd;
      SMTP->AuthType = smtpAuthCramMD5; // set as a flag that auth required, may select another protocol in onresponse
   }

   HeadMan->Delete("Sign-On: ");
   HeadMan->Delete("Proxy: ");
   HeadMan->Delete("Tor: ");
   HeadMan->Delete("Socks: ");
   HeadMan->Delete("Sent: ");
   HeadMan->Delete("Host: ");
   HeadMan->Delete("Bcc: ");
   HeadMan->Delete("Fcc: ");

   return true;
}*/
//---------------------------------------------------------------------------

bool __fastcall TSmtpDlg::CutMessageAtMark()
{
   bool cut=false;
   if (Message->Text.Pos("\r\n"+CutMarks+"\r\n"))
   {
      for (int i=Message->Count-1; i>0; i--) // remove cutmarked portion of message
      {
         if (Message->Strings[i]==CutMarks)
         {
            while (Message->Count>i) Message->Delete(i);
            cut = true;
            break;
         }
      }
   }
   // remove all trailing empty lines and add a single one back;
   while (Message->Count && Message->Strings[Message->Count-1].Trim().IsEmpty())
      Message->Delete(Message->Count-1);
   Message->Add("");
   return cut;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TSmtpDlg::GetMessageName()
{
   // returns the name of the last message not mixchain
   return !MessageNameOrg.IsEmpty() ? MessageNameOrg:MessageName;
}

//---------------------------------------------------------------------------

long __fastcall TSmtpDlg::DoMixmasterMessage(TStrings *message)
{
   int pos;
   AppProcessMessages();
   LastMixDateTime = "";
   LastMixFeedback->Clear();
   DISPLAY("Encountered mixmaster message");

   AppProcessMessages();
   ActiveControl = Panel1;
   AnsiString cap=Caption;
   for (int i=0; i<4; i++)
   {
      if (Caption.IsEmpty()) Caption = "Encrypting..."; else Caption = "";
      Sleep(300);
   }
   ActiveControl = Display;
   AppProcessMessages();

   int msgsize = message->Text.Length();

   Display->Cursor = crHourGlass;
   MixMan = new TMixMessage(this, (TStringList*)message, Display->Lines, ProgressBar, LastMixFeedback);
   int Result = MixMan->Execute();
   if (MixMan->Cancelled) Cancel();
   delete MixMan; MixMan=NULL;
   Display->Cursor = crDefault;
   Caption = cap;

   AnsiString fb = LastMixFeedback->Text;
   if ((pos = fb.Pos("Chain: ")) > 0)
   {
      fb.Delete(pos, 7);
      LastMixFeedback->Text = fb;
   }

   LastMixCount = 0;

   if (!Cancelled && Result == 0 && LastMixFeedback->Count > 0 &&
       !CheckExitRemailerKlen(this, LastMixFeedback->Strings[0], msgsize)) //, hasAttached))
   {
      Cancel();
   }

   if (!Cancelled)
   {
      Application->ProcessMessages();
      if (Result != 0)
      {
         ProgressBar->Visible = false;
         Abort();
      }
   }

   return Result;
}
//---------------------------------------------------------------------------
/*long __fastcall TSmtpDlg::DoCypherpunkMessage()
{
   int pos;
   AppProcessMessages();
   LastMixFeedback->Clear();
   LastMixDateTime = "";
   DISPLAY("Encountered cypherpunk message");

   AppProcessMessages();
   ActiveControl = Panel1;
   AnsiString cap=Caption;
   for (int i=0; i<4; i++)
   {
      if (Caption.IsEmpty()) Caption = "Encrypting..."; else Caption = "";
      Sleep(300);
   }
   ActiveControl = Display;
   AppProcessMessages();

   Display->Cursor = crHourGlass;
   MixMan = new TMixMessage(Message,Display->Lines,ProgressBar,LastMixFeedback);
   int Result = MixMan->Execute();
   delete MixMan; MixMan=NULL;
   Display->Cursor = crDefault;
   Caption = cap;

   AnsiString fb = LastMixFeedback->Text;
   if ((pos=fb.Pos("Chain: "))>0)
   {
      fb.Delete(pos,7);
      LastMixFeedback->Text = fb;
   }
   LastMixCount = 0;

   if (!Cancelled)
   {
      Application->ProcessMessages();
      if (Result!=0)
      {
         PB->Visible = false;
         Abort();
      }
   }
   return Result;
   return 0;
}*/
//---------------------------------------------------------------------------
bool __fastcall TSmtpDlg::IsPgpSignedMessage(TStrings *msg)
{
   bool pgpsigned = false;
   for (int i=0; i<msg->Count; i++)
   {
      if (i<msg->Count-1 && msg->Strings[i].Trim().IsEmpty() &&
         msg->Strings[i+1].Trim()==BeginPgpSignedMessage)
      {
         pgpsigned = true;
         break;
      }
   }
   return pgpsigned;
}
//---------------------------------------------------------------------------
/*void __fastcall TSmtpDlg::MassageNewsgroupsAndReferencesAndSubject()
{
   int nidx,fidx,aidx;
   AnsiString ngrps,fgrps,arefs;
   HeadMan->HereIs(Message);
   // followup-to header
   fgrps = HeadMan->GetFollowupTo();
   fidx = HeadMan->Delete("Followup-To: ");
   if (!fgrps.IsEmpty() && fidx>=0) Message->Insert(fidx,"Followup-To: "+fgrps);
   // newsgroups header
   ngrps = HeadMan->GetNewsgroups();
   nidx = HeadMan->Delete("Newsgroups: ");
   if (!ngrps.IsEmpty() && nidx>=0) Message->Insert(nidx,"Newsgroups: "+ngrps);
   // references header
   arefs = HeadMan->GetReferences();
   aidx = HeadMan->Delete("References: ");
   if (!arefs.IsEmpty() && aidx>=0) Message->Insert(aidx,"References: "+arefs);
   // subject header
   AnsiString sub;
   TStringList *subject = new TStringList();
   subject->Text = HeadMan->GetDat("Subject: ");
   if (subject->Count>1)
   {
      sub = subject->Strings[0].Trim();
      for (int i=1; i<subject->Count; i++)
         sub += " "+subject->Strings[i].Trim();
      int pos = HeadMan->Delete("Subject: ");
      if (pos>=0) Message->Insert(pos,"Subject: "+sub);
      else
      {
         pos = HeadMan->IndexOf("To: ");
         Message->Insert(pos,"Subject: "+sub);
      }
   }
   delete subject;
}*/
//---------------------------------------------------------------------------

/*bool __fastcall TSmtpDlg::CheckUsingSocks(TStrings *message)
{
   SMTP->CtrlSocket->SocksPort = "";
   SMTP->CtrlSocket->SocksLevel = "4";
   SMTP->CtrlSocket->SocksServer = "";
   SMTP->SignOn = "";
   UseSocks = false;

   THeaderManager *hm = new THeaderManager(message);
   AnsiString socksparams = hm->GetDat("Tor: ").Trim();
   if (socksparams.IsEmpty())
      socksparams = hm->GetDat("Socks: ").Trim();
   if (!socksparams.IsEmpty())
   {
      AnsiString ipport, ip, port, level;
      ipport = GetToken(0, socksparams, ",");
      level = GetToken(1, socksparams, ",").Trim();
      level = GetToken(0, level, ";").Trim();
      port = GetToken(1, ipport, ":");
      ip = GetToken(0, ipport, ":");

      if (level != "4" && level != "4a" && level != "5")
      {
         MsgBoxHwnd(Handle,
            "Invalid socks level! It must be 4, 4a or 5",
            "Socks Error", MB_OK);
         return false;
      }

      SocksServer = ip;
      SocksPort = port;
      SocksLevel = level;
      TORSignOn = hm->GetDat("Sign-On: ");
      if (TORSignOn.IsEmpty())
         TORSignOn = "nowhere.invalid",

      hm->Delete("Socks: ");
      hm->Delete("Tor: ");

      UseSocks = true;
   }
   delete hm;

   return true;
}*/
//---------------------------------------------------------------------------

void __fastcall TSmtpDlg::GetSpecialHeaders(TStrings *message)
{
   AnsiString header;
   specialheaders->Clear();
   THeaderManager *hm = new THeaderManager(message);

   header = hm->Get("Sign-On: ");
   if (!header.IsEmpty())
   {
      specialheaders->Add(header);
      hm->Delete("Sign-On: ");
   }

   header = hm->Get("Socks: ");
   if (!header.IsEmpty())
   {
      specialheaders->Add(header);
      hm->Delete("Socks: ");
   }

   header = hm->Get("Tor: ");
   if (!header.IsEmpty())
   {
      specialheaders->Add(header);
      hm->Delete("Tor: ");
   }

   header = hm->Get("Proxy: ");
   if (!header.IsEmpty())
   {
      specialheaders->Add(header);
      hm->Delete("Proxy: ");
   }

   delete hm;
}
//---------------------------------------------------------------------------
#define STRING(int) AnsiString(int)
bool __fastcall TSmtpDlg::GetNextMessage()
{
   if (!MixPoolCount() && !Messages->Count) return false;
   // setup for next message
   THeaderManager *hm = new THeaderManager(Message);
   if (MixPoolCount())
   {
      TStringList *pool = new TStringList();
      if (MessageNameOrg.IsEmpty()) MessageNameOrg = MessageName;
      MixPoolGet(Message,MessageName,0);
      MixPoolDelete(0);
      delete pool;
   }
   else
   {
      MessageNameOrg = "";
      MessageName = Messages->Strings[0];
      GetAppData(Message,MailQueue+PS+MessageName);    // get from queue
      PutAppData(MailQueue+PS+MessageName,NULL);       // delete from queue
      PutAppData(ProblemQueue+PS+MessageName, Message); // store temporary in probs
      Messages->Delete(0);
      GetSpecialHeaders(Message);

      NymLogEntry = hm->GetDat("Nym-Log: ");
      hm->Delete("Nym-Log: ");
   }
   Send2Dir = hm->GetDat("Host: ");
   hm->Delete(ClrTextHdr);
   delete hm;

   if (!WrapMessage(Message,-1))
   {
      return false;
   }

   CancelBtn->Enabled = true;
   HelpBtn->Enabled = false;
   ProblemRpt->Clear();

   NymConfigNym = "";

   HeadDone = false;
   BodyDone = false;

   // exhaustively search last lines for cr lf tab space
   int l; while (true)
   {
      AnsiString line = Message->Strings[Message->Count-1];
      while ((l=line.Length())>0 &&
         (line[l]=='\r'||line[l]=='\n'||line[l]=='\t'||line[l]==' '))
            line.SetLength(l-1);
      if (line.IsEmpty()) Message->Delete(Message->Count-1);
      else break;
   }

   Message->Add("");
   return true;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TSmtpDlg::SendingCurrentMessageString()
{
   TStrings *display=Display->Lines;
   AnsiString message,current,maximum;
   if (MessageName.Pos(MixmasterChain)==1) message = MessageName;
   else
   {
      current = AnsiString(++curmsg);
      maximum = AnsiString(Messages->Count+curmsg);
      message = "Sending Message "+current+" of "+maximum;
   }
   if (display->Count && !display->Strings[display->Count-1].IsEmpty())
      message = "\r\n" + message;
   return message;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::GoNext()
{
   Message->Clear();
   PostMessage(Handle,WM_NEXTMESSAGE,0,0L);
}
//---------------------------------------------------------------------------
bool __fastcall TSmtpDlg::HasHeader(AnsiString &Header, TStrings *message)
{
   THeaderManager *hm = new THeaderManager(message);
   bool ok = !hm->GetDat(Header,Message).IsEmpty();
   delete hm;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TSmtpDlg::DupleRemailers(AnsiString &keyring, AnsiString &typfile)
{
   int c;
   AnsiString shrt;
   bool dups=false;
   TStringList *type2=new TStringList();
   TStringList *shrts=new TStringList();
   TMixKeyList2 *keys=new TMixKeyList2(keyring);
   MixGetType2(type2);
   for (int i=0; i<keys->Count; i++)
   {
      shrt = keys->Key(i)->name;
      c = shrts->Values[shrt].ToIntDef(0);
      shrts->Values[shrt] = s(c+1);
      for (int t=0; t<type2->Count; t++)
      {
         if (type2->Strings[t]=="#"+keys->Key(i)->Strings[0])
         {
            c = shrts->Values[shrt].ToIntDef(0);
            shrts->Values[shrt] = s(c-1);
            break;
         }
      }
   }
   for (int i=0; i<shrts->Count; i++)
   {
      c = shrts->Values[shrts->Names[i]].ToIntDef(0);
      if (c>1)
      {
         MsgBoxHwnd(Handle,
            s("You have "+s(c)+" duplicate keys for remailer '"+shrts->Names[i]+"'.    \r\n")+
            s("You'll need to disable "+s(c-1)+" of these before\r\n")+
            s("you can continue with this send."),
            s("Remailer Key Error"),
            MB_OK
         );
         dups = true;
         break;
      }
   }
   delete type2;
   delete shrts;
   delete keys;
   return dups;
}
//---------------------------------------------------------------------------

bool __fastcall TSmtpDlg::SendMailToDirectory()
{
   if (Send2Dir.Pos(":")==2 && Send2Dir.Pos("\\")>2) return true;
   if (DirectoryExists(Send2Dir)) return true;
   return false;
}
//---------------------------------------------------------------------------

void __fastcall TSmtpDlg::SendMessageToDirectory()
{
   AnsiString incstr,msgfile;
   if (!DirectoryExists(Send2Dir)) ForceDirectories(Send2Dir);
   if (!DirectoryExists(Send2Dir))
   {
      BingBox(this,
         s("In the program options, you have indicated you wish your mail\n")+
         s("placed in the directory: "+Send2Dir+"\n\n")+
         s("The directory does not exist and I was unable to create it. I'm\n")+
         s("cancelling. You'll need to open Options Dialog, Sending Mail page\n")+
         s("and fix the directory."),
         s("Mail To Directory"),MB_OK);
      Cancelled = true;
      return;
   }

   int clrtxt;
   static int increment = 0;
   static AnsiString lastdatetime = "";
   AnsiString datetime=FormatDateTime("yymmddhhnnss",Now());
   if (datetime==lastdatetime) increment++;
   else increment = 0;
   incstr = s(increment); if (incstr.Length()<2) incstr = "0"+incstr;
   msgfile = AddBS(Send2Dir)+"msg"+datetime+incstr+".txt";

   DISPLAY("Sending to-> " + msgfile);
   Message->SaveToFile(msgfile);

   AnsiString IdxStr, CntStr;
   bool isChain = MessageName.Pos(MixmasterChain) == 1;
   if (isChain && LastMixFeedback->Count)
   {
      LastMixCount++;
      int count=LastMixFeedback->Count;
      TStringList *msg = new TStringList();
      TStringList *log = new TStringList();

      GetAppData(msg,ProblemQueue+PS+GetMessageName());
      CntStr = count>1 ? s("   "+s(LastMixCount)+") "):s("   ");
      if (LastMixDateTime.IsEmpty())
         LastMixDateTime = HeadMan->DateTimeOut();
      IdxStr = LastMixDateTime+" "+HeadMan->GetDat("Subject: ",msg)+"                                                  ";
      IdxStr = IdxStr.SubString(1,53)+CntStr+LastMixFeedback->Strings[LastMixCount-1].Trim();

      GetAppData(log,ChainLog); log->Add(IdxStr);
      int max=GetAppIni(ChainLogMax,"").ToIntDef(16);
      while (max && log->Count > max)
         log->Delete(0);
      PutAppData(ChainLog, log);

      delete log;
      delete msg;
   }
   // if it is not a chain, do it
   // if it is a chain and also last in pool, do it
   // if it is chain and not last in pool, don't do it
   if (!isChain || (isChain && !MixPoolCount()))
   {
      TStringList *msg = new TStringList();
      TStringList *replay = new TStringList();
      GetAppData(msg,ProblemQueue+PS+GetMessageName());
      AnsiString Fcc = HeadMan->GetDat("Fcc: ",msg);
      HeadMan->Delete(WordWrapHeader,msg);

      if ((clrtxt=QSPoolHeaderToClearText(msg))>0)
      {
         replay->Text = msg->Text;
         QSPoolGet(msg,clrtxt);
      }

      if (!Fcc.IsEmpty())
      {
         HeadMan->Delete("Date: ");
         FileCopyMail(Fcc, msg);
      }

      if (IsNymConfigMessage(msg, NymConfigNym)) // && !IsNymDeleteMsg(msg))
      {
         HeadMan->Delete(NymConfigHdr); // in case any linger
         //if (ISDESIGNING)
         replay->Insert(0,"Sent: "+FormatDateTime("mm-dd-yyyy hh:nn:ss ampm", Now()));

         if (!FileExists(AppDir + "qsnym.exe"))
         {
            PutAppData(NymReplaysKey + PS + NymConfigNym, replay);
            PutAppData(NymConfigsKey + PS + NymConfigNym, msg);
         }
         else
         {
            assert(NymLogEntry != "");

            LogNymMessage(NymConfigNym, NymLogEntry);
            NewSaveReplay(NymConfigNym, replay);
         }
      }

      PutAppData(ProblemQueue+PS+GetMessageName(), NULL);
      delete replay;
      delete msg;
   }

   NymConfigNym = "";
   //NymLogEntry = "";

   if (!Cancelled && (Messages->Count || MixPoolCount()))
   {
      lastdatetime = datetime;
      PostMessage(Handle,WM_NEXTMESSAGE,0,0L);
      return;
   }

   DISPLAY("");
   ShowExitInfo();
}
//---------------------------------------------------------------------------

bool __fastcall EncodeTheMessage(TForm *Owner, TStrings *Message)
{
   Snooze(300);
   bool ok = EncodeMIMEAttachments(Owner,Message);
//view(Message);
   return ok;
}

//---------------------------------------------------------------------------

bool __fastcall TSmtpDlg::MoveRecipsToCC(TStrings *message)
{
   int i, len, pos;
   AnsiString recip;
   bool ispost = HasHeader("Post: ", message);

   THeaderManager *hm = new THeaderManager(message);

   TStringList *tos = new TStringList();
   AnsiString torecips = hm->GetDat("To: ");

   while ((pos = torecips.Pos("\r")) > 0) torecips.Delete(pos, 1);
   while ((pos = torecips.Pos("\n")) > 0) torecips.Delete(pos, 1);
   while ((pos = torecips.Pos("\t")) > 0) torecips.Delete(pos, 1);
   i = 0; while ((recip = GetToken(i, torecips, ",")) != "")
   {
      tos->Add(recip.Trim());
      i++;
   }

   if (!tos->Count)
   {
      delete tos;
      delete hm;

      if (ispost)
         return true;

      return false;
   }

   TStringList *ccs = new TStringList();
   AnsiString ccrecips = hm->GetDat("Cc: ");

   while ((pos = ccrecips.Pos("\r")) > 0) ccrecips.Delete(pos, 1);
   while ((pos = ccrecips.Pos("\n")) > 0) ccrecips.Delete(pos, 1);
   while ((pos = torecips.Pos("\t")) > 0) ccrecips.Delete(pos, 1);
   i = 0; while ((recip = GetToken(i, ccrecips, ",")) != "")
   {
      ccs->Add(recip.Trim());
      i++;
   }

   assert(tos->Count > 0);

   len = 2;
   i = 0; while (i < tos->Count)
   {
      len += tos->Strings[i].Length() + 2;
      if (len > 79)
         break;

      i++;
   }

   pos = 0;
   while (i < tos->Count)
   {
      ccs->Insert(pos, tos->Strings[i]);
      tos->Delete(i);
      pos++;
   }

   torecips = ""; for (i = 0; i < tos->Count; i++)
   {
      torecips += " " + tos->Strings[i];
      if (i < tos->Count - 1)
         torecips += ",";
   }

   ccrecips = ""; for (i = 0; i < ccs->Count; i++)
   {
      ccrecips += " " + ccs->Strings[i];
      if (i < ccs->Count - 1)
         ccrecips += ",";
   }

   hm->Delete("Cc: ");
   int idx = hm->Delete("To: ");

   if (!ccrecips.IsEmpty())
      message->Insert(idx, "Cc:" + ccrecips);
   message->Insert(idx, "To:" + torecips);

   delete ccs;
   delete tos;
   delete hm;

   return true;
}
//---------------------------------------------------------------------------

void __fastcall CheckSubject4Mods(TStrings *Message)
{
   for (int i = 0; i < Message->Count; i++)
   {
      AnsiString line = Message->Strings[i];
      if (line.IsEmpty())
         break;

      if (line.Pos("Subject: ") == 1)
      {
         int p = line.Pos("%mmdd%");
         if (p > 0)
         {
            line.Delete(p, 6);
            line.Insert(FormatDateTime("mm/dd", Now()), p);
            Message->Strings[i] = line;
         }
         break;
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TSmtpDlg::DoSendMessage()
{
   if (Cancelled)
      return;

   if (!GetNextMessage())
   {
      Abort();
      ShowExitInfo();
      return;
   }

   ActiveControl = Display;
   DISPLAY(SendingCurrentMessageString());
   CutMessageAtMark();

   if (HasHeader("Subject: ", Message))
   {
      CheckSubject4Mods(Message);
   }

   if (HasHeader("Attachment: ", Message) && !EncodeTheMessage(this, Message))
   {
      GoNext();
      return;
   }

   if (Cancelled)
      return;

   if (HasHeader("Chain: ", Message))
   {
      if ( DupleRemailers(mringtxt, mtyp2txt)) { Abort(); return; }
      if (!MoveRecipsToCC(Message)) { Abort(); return; }
      if ( DoMixmasterMessage(Message) != 0) Abort();
      if (!Cancelled) GoNext();
      return;
   }

   if (!PrepareMail()) { GoNext(); return; }

   /*if (ISDESIGNING)
   {
      AnsiString count,fname=AppDir+"0linecounts.txt";
      TStringList *lines = new TStringList();
      if (FileExists(fname)) lines->LoadFromFile(fname);
      count = s(Message->Count); while (count.Length()<4) count = " "+count;
      lines->Add(count+" "+HeadMan->GetDat("Subject: "));
      lines->SaveToFile(fname);
      delete lines;
   }*/

   if (SendMailToDirectory())
   {
      if (WarnSendMailToDirectory(this,Send2Dir))
      {
         SendMessageToDirectory();
         return;
      }
      Abort();
      ShowExitInfo();
      return;
   }

   DISPLAY("Proxy: " + GetToken(0, proxyname, ","));
   DISPLAY("Connecting...");
   while (SMTP->State != smtpReady && !Application->Terminated && !Cancelled)
      continue;

   SMTP->Open();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::WMNextMessage(TMessage& Msg)
{
   LastError=0; DoSendMessage();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::ReturnCurrentToQueue()
{
   TStringList *msg = new TStringList();
   GetAppData(msg,ProblemQueue+PS+GetMessageName());
   if (msg->Count && ProblemRpt->Count==0)
   {
      PutAppData(MailQueue+PS+GetMessageName(),msg);
      PutAppData(ProblemQueue+PS+GetMessageName(),NULL);
   }
   delete msg;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::Except(Exception *E)
{
   AnsiString ExceptionError = "Exception: "+E->Message;
   ProblemRpt->Add(ExceptionError);
   DISPLAY(ExceptionError);
   DISPLAY("Aborting...");

   MixPoolDeleteFile();
   SaveProblemMessage(MessageName,ProblemRpt);
   //if (MimeMan) MimeMan->Cancelled = true;
   if (MixMan) MixMan->Cancelled = true;
   ProgressBar->Visible = false;
   CancelBtn->Caption = Shit;
   HelpBtn->Enabled = true;
   Cancelled = true;
   Excepted = true;
   Aborted = true;
   SMTP->Abort();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::Abort(WORD Error)
{
   if (Cancelled) return;
   if (Error)
   {
      AnsiString WinsockError =
         "Winsock Error: "+AnsiString(Error)+" "+WSocketErrorDesc(Error);
      AnsiString SmtpError = SMTP->ErrorMessage;
      if (SmtpError.IsEmpty()) SmtpError = "Not an SMTP error";
      ProblemRpt->Add("SMTP Error: "+SmtpError);
      ProblemRpt->Add(WinsockError);
      if (WinsockError.Pos("Not a WinSock error") == 0)
         DISPLAY(WinsockError);
   }
   DISPLAY("Aborting...");

   MixPoolDeleteFile();
   SaveProblemMessage(GetMessageName(),ProblemRpt);
   //if (MimeMan) MimeMan->Cancelled = true;
   if (MixMan) MixMan->Cancelled = true;
   ProgressBar->Visible = false;
   CancelBtn->Caption = Shit;
   HelpBtn->Enabled = true;
   Cancelled = true;
   Aborted = true;
   SMTP->Abort();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::Cancel()
{
   MixPoolDeleteFile();
   if (!Display->Lines->Strings[Display->Lines->Count-1].IsEmpty())
      DISPLAY("");
   DISPLAY("Send cancelled by user!");
   /*if (MimeMan)
   {
      MimeMan->Cancelled = true;
      //ReturnCurrentToQueue();
      //ShowExitInfo();
   }*/
   if (MixMan)
   {
      MixMan->Cancelled = true;
      //ReturnCurrentToQueue();
      //ShowExitInfo();
   }
   SMTP->Abort();
   if (Display->Lines->Text.Pos("Session finished")==0)
   {
      //ReturnCurrentToQueue();
      //ShowExitInfo();
   }
   ProgressBar->Visible = false;
   CancelBtn->Caption = "Ok";
   HelpBtn->Enabled = true;
   Cancelled = true;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::CancelBtnClick(TObject *Sender)
{
   if (CancelBtn->Caption=="Ok" || CancelBtn->Caption==Shit)
   {
      ModalResult = LastError || Cancelled ? mrCancel:mrOk;
      if (ModalResult==mrOk && SendMailToDirectory())
         OpenMail2DiskDirectory(this,Send2Dir);
      return;
   }
   if (CancelBtn->Caption=="Cancel")
   {
      if (BytesSent!=BytesTotal) Cancel();
      TapQueues();
   }
   ActiveControl = Display;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (CancelBtn->Caption=="Cancel")
   {
      CancelBtn->Click(); MyBeep(MB_OK); CanClose = false;
      ProgressBar->Visible = false;
      HelpBtn->Enabled = true;
      SendBtn->Visible = true;
      AuthBtn->Visible = true;
      Messages->Clear();
      return;
   }
   SaveSMTPlog();
   TapQueues();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::ShowExitInfo()
{
   AnsiString S;
   int msgs=0,probs=0;
   HelpBtn->Enabled = true;
   CancelBtn->Enabled = true;
   TStringList *msg = new TStringList();
   if (AppDataExists(ProblemQueue,msg))
   {
      MyBeep(MB_ICONHAND);
      S = msg->Count>1 ? "s":"";
      DISPLAY("ERROR: "+AnsiString(msg->Count)+" unsent message"+S+" in PROBLEM Queue!");
      SendBtn->Visible = true;
      AuthBtn->Visible = true;
      probs = msg->Count;
   }
   if (AppDataExists(MailQueue,msg))
   {
      S = msg->Count>1 ? "s":"";
      DISPLAY(AnsiString(msg->Count)+" unsent message"+S+" in Mail Queue!");
      SendBtn->Visible = true;
      AuthBtn->Visible = true;
      msgs = msg->Count;
   }
   if (!msgs && !probs)
   {
      if (!AppMainForm->MDIChildCount) QSPoolClear();
      DISPLAY("All mail sent");
   }
   CancelBtn->Caption = SMTP->ErrorMessage.IsEmpty() ? AnsiString("Ok"):Shit;
   DISPLAY("Session finished");
   ProgressBar->Visible = false;
   //SendBtn->Enabled = msgs>0;
   SendBtn->Visible = true;
   AuthBtn->Visible = true;
   TapQueues();
   delete msg;

   if (AndClose)
   {
      ModalResult = mrOk;
   }
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::ExceptionHandler(TObject *Sender, Exception *E)
{
   Except(E);
   ShowExitInfo();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::SMTPDisplay(TObject *Sender, AnsiString Msg)
{
   TStrings *lines = Display->Lines;
   if (lines->Count && lines->Strings[lines->Count-1].Pos(" Connecting...")==1)
       lines->Add(" Connected to "+SMTP->Host);

   if (Msg.SubString(1,1)=="<") lines->Add(Msg.SubString(2,255));
}
//---------------------------------------------------------------------------
/*void __fastcall TSmtpDlg::SMTPGetData(TObject *Sender, int LineNum,
	Pointer MsgLine, int MaxLen, bool &More)
{

}*/
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::SMTPGetData(TObject *Sender, int LineNum, Pointer MsgLine,
   int MaxLen, bool &More)
{
   HeadDone = true;
   ProgressBar->Position = ((double)BytesSent/(double)BytesTotal)*100;
   Application->ProcessMessages();

   if (LineNum>Body->Count)
   {
      ProgressBar->Position = 100; Snooze(200);
      BodyDone = true;
      More = false;
      return;
   }
   AnsiString line=Body->Strings[LineNum-1]; //line.Unique();
   // test for lines longer than maxlen
   int wwAt=MaxLen-1;
   if (line.Length()>MaxLen-1)
   {
      for (int i=MaxLen-1; i>0; i--)
         if (line[i]==' ' || line[i]=='-')
         {
            wwAt=i;
            break;
         }
      Body->Insert(LineNum,line.SubString(wwAt+1,2147483647-wwAt));
      line = line.SubString(1,wwAt);
   }
   strcpy((char*)MsgLine,line.c_str());
   BytesSent += line.Length()+2;
}
//---------------------------------------------------------------------------
/*void __fastcall TSmtpDlg::SMTPGetData(TObject *Sender, int LineNum,
	PChar MsgLine, int MaxLen, bool &More)
{
   HeadDone = true;
   ProgressBar->Position = (WORD)(BytesSent/BytesTotal*100);
   Application->ProcessMessages();

   if (LineNum>Body->Count)
   {
      BodyDone = true;
      More = false;
      return;
   }
   // test for lines longer than maxlen
   int wwAt=MaxLen;
   AnsiString line=Body->Strings[LineNum-1];
   if (line.Length()>MaxLen)
   {
      for (int i=MaxLen; i>0; i--)
         if (line[i]==' ' || line[i]=='-')
         {
            wwAt=i;
            break;
         }

      if (LineNum==Body->Count) Body->Add(line.SubString(wwAt+1,10240000));
      else Body->Insert(LineNum,line.SubString(wwAt+1,10240000));
      line = line.SubString(1,wwAt);
   }
   strcpy(MsgLine,line.c_str());
   BytesSent += line.Length()+2;
}*/
//---------------------------------------------------------------------------
/*void __fastcall TSmtpDlg::SMTPRequestDone(TObject *Sender, TSmtpRequest RqType,
   WORD Error)
{
   if (Error)
   {
      Abort(Error);
      return;
   }
   switch (RqType)
   {
      case smtpConnect: SMTP->Helo(); break;
      case smtpHelo: SMTP->MailFrom(); break;
      case smtpMailFrom: SMTP->RcptTo(); break;
      case smtpRcptTo:
         ProgressBar->Visible = true;
         SMTP->Data();
         break;
      case smtpRset:
      case smtpData:
         SMTP->Quit();
         break;
      case smtpQuit:
         ProgressBar->Visible = false;
         if (SMTP->Host.LowerCase().Pos(".netzero.net")>0)
             SMTP->WSocket->Close();
         break;
   }
}*/
//---------------------------------------------------------------------------
bool __fastcall TSmtpDlg::NeedsSMTPAuthentication(AnsiString host, AnsiString &userid,
   AnsiString &password)
{
   TStringList *hosts = new TStringList();
   GetAppData(hosts,SMTPAuthenticHosts);
   AnsiString data = hosts->Values[host];
   password = GetToken(1,data,"\255");
   userid = GetToken(0,data,"\255");
   delete hosts;
   return !data.IsEmpty();
}
//---------------------------------------------------------------------------
bool __fastcall TSmtpDlg::HasAUTHCommand(AnsiString &Mechanism)
{
   AnsiString mech;
   for (int i=0; i<Display->Lines->Count; i++)
   {
      AnsiString line = Display->Lines->Strings[i].Trim().UpperCase();
      //if (line.Pos("250-AUTH=")==1 || line.Pos("250-AUTH ")==1 ||
      //    line.Pos("250 AUTH=")==1 || line.Pos("250 AUTH ")==1)
      if (line.Pos("250")==1 && line.Pos("AUTH")==5)
      {
         mech = line.SubString(10,64);
         if (s(" "+mech+" ").Pos(" LOGIN ")>0)
         {
            mech = "LOGIN";
            Display->Lines->Add(" Using "+mech+" authentication.");
            break;
         }
         else
         {
            Display->Lines->Add("=======================================================");
            Display->Lines->Add("Host uses login protocol(s) not supported by QuickSilver");
            Display->Lines->Add("Please copy this entire conversation into an email and");
            Display->Lines->Add("send to: quicksilver@quicksilvermail.net");
            Display->Lines->Add("The protocol will be supported shortly. Probably!");
            Display->Lines->Add("========================================================");
         }
         break;
      }
   }
   if (mech.IsEmpty()) Display->Lines->Add(
      "Host does not support authenticated login.\nTrying unauthenticated...");
   else Mechanism = mech;
   return !mech.IsEmpty();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::SMTPRequestDone(TObject *Sender, TSmtpRequest RqType,
   WORD Error)
{
   if (Error)
   {
      Abort(Error);
      return;
   }

   switch (RqType)
   {
      case smtpOpen:
         ProgressBar->Visible = true;
         SMTP->Mail();
         break;
      case smtpMail:
         SMTP->Quit();
         break;
      case smtpQuit:
         if (!Cancelled && !Aborted && !Excepted)
         {
            ProgressBar->Position = 100;
            Snooze(100);
         }
         ProgressBar->Visible = false;
         if (SMTP->Host.LowerCase().Pos(".netzero.net")>0)
             SMTP->CtrlSocket->Close();
         break;
   }
}
/*void __fastcall TSmtpDlg::SMTPRequestDone(TObject *Sender, TSmtpRequest RqType,
   WORD Error)
{
   if (Error)
   {
      Abort(Error);
      return;
   }
   AnsiString userid,passwd,authmech;
   switch (RqType)
   {
      case smtpConnect:
         Snooze(100);
         SMTP->Ehlo();
         break;
      case smtpEhlo:
         if (SMTP->AuthType != smtpAuthNone)
         {
            SMTP->Auth();
            break;
         }
      case smtpAuth:
      case smtpHelo: SMTP->MailFrom(); break;
      case smtpMailFrom: SMTP->RcptTo(); break;
      case smtpRcptTo:
         ProgressBar->Visible = true;
         SMTP->Data();
         break;
      case smtpRset:
      case smtpData:
         SMTP->Quit();
         break;
      case smtpQuit:
         if (!Cancelled && !Aborted && !Excepted)
         {
            ProgressBar->Position = 100;
            Snooze(100);
         }
         ProgressBar->Visible = false;
         if (SMTP->Host.LowerCase().Pos(".netzero.net")>0)
             SMTP->CtrlSocket->Close();
         //Snooze(200);
         break;
   }
}*/
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::SMTPProcessHeader(TObject *Sender,
	TStrings *HdrLines)
{
   /*for (int i = 0; i < Head->Count; i++)
   {
      AnsiString fixed, line = Head->Strings[i];
      if (line.Pos("Subject:") == 1)
      {
         fixed = CheckHeader4Mods(line);
         if (fixed != line)
            Head->Strings[i] = fixed;
      }
   }*/
   HdrLines->Text = Head->Text;
}
//---------------------------------------------------------------------------

void __fastcall TSmtpDlg::FileCopyMail(AnsiString &ToMailbox, TStrings* Message)
{
   if (!MailboxExists(ToMailbox)) CreateMailbox(ToMailbox);
   // save the message
   PutAppData(UserMailboxes+PS+ToMailbox+PS+HeadMan->IndexString(Message),Message);
   // refresh index if it is open
   if ((MailboxWin=FindOpenMailbox(ToMailbox))!=NULL)
      MailboxWin->MailGrid->RefreshIndex();
}
//---------------------------------------------------------------------------

void __fastcall TSmtpDlg::LogNymMessage(AnsiString nym, AnsiString entry)
{
   TStringList *profile = new TStringList();
   TStringList *profiles = new TStringList();

   bool gotnym = false;
   // get full index string from name
   GetAppData(profiles, NymProfilesKey2);
   for (int i = 0; i < profiles->Count; i++)
   {
      AnsiString line = profiles->Strings[i];
      if (line.Pos(nym + "\255") == 1)
      {
         gotnym = true;
         nym = line;
         break;
      }
   }

   assert(gotnym == true);

   GetAppData(profile, NymProfilesKey2 + PS + nym);

   int i = 0; while (i < profile->Count)
   {
      if (profile->Strings[i].Pos("Log:") == 1)
      {
         while (++i < profile->Count)
         {
            if (profile->Strings[i].Trim().IsEmpty())
            {
               profile->Insert(i, FormatDateTime("yyyy-mm-dd hh:mm", Now()) + "  sent " + entry);
               break;
            }
         }
      }
      i++;
   }

   PutAppData(NymProfilesKey2 + PS + nym, profile);

   delete profiles;
   delete profile;
}
//---------------------------------------------------------------------------

void __fastcall TSmtpDlg::NewSaveReplay(AnsiString nym, TStrings *replay)
{
   TStrings *profile = new TStringList();
   TStrings *profiles = new TStringList();

   bool gotnym = false;
   // get full index string from name
   GetAppData(profiles, NymProfilesKey2);
   for (int i = 0; i < profiles->Count; i++)
   {
      AnsiString line = profiles->Strings[i];
      if (line.Pos(nym + "\255") == 1)
      {
         gotnym = true;
         nym = line;
         break;
      }
   }

   assert(gotnym == true);

   GetAppData(profile, NymProfilesKey2 + PS + nym);

   int i = 0; while (i < profile->Count)
   {
      if (profile->Strings[i].Pos("Sent:") == 1)
      {
         while (i < profile->Count)
         {
            if (profile->Strings[i].Pos("Log:") == 1)
               break;

            profile->Delete(i);
         }
         break;
      }

      i++;
   }

   for (int x = 0; x < replay->Count; x++)
   {
      profile->Insert(i + x, replay->Strings[x]);
   }

   PutAppData(NymProfilesKey2 + PS + nym, profile);

   delete profiles;
   delete profile;
}
//---------------------------------------------------------------------------

void __fastcall TSmtpDlg::SMTPSessionClosed(TObject *Sender, WORD Error)
{
   int clrtxt;
   AnsiString IdxStr,CntStr;
   DISPLAY("Connection closed!\r\n");

   if (Error)
   {
      AnsiString WinsockError =
         "Winsock Error: "+AnsiString(Error)+" "+WSocketErrorDesc(Error)+" xxx";
      AnsiString SmtpError = SMTP->ErrorMessage;
      if (SmtpError.IsEmpty()) SmtpError = "Not an SMTP error";

      ProblemRpt->Add("SMTP Error: "+SmtpError);
      ProblemRpt->Add(WinsockError);
      //if (WinsockError.Pos("Not a WinSock error") == 0)
         DISPLAY(WinsockError);
   }
   if (BytesSent==BytesTotal)
   {
      bool isChain = MessageName.Pos(MixmasterChain)>0;
      if (isChain && LastMixFeedback->Count)
      {
         LastMixCount++;
         int count=LastMixFeedback->Count;
         TStringList *msg = new TStringList();
         TStringList *log = new TStringList();
         GetAppData(msg,ProblemQueue+PS+GetMessageName());
         CntStr = count>1 ? s("   "+s(LastMixCount)+") "):s("   ");
         if (LastMixDateTime.IsEmpty()) LastMixDateTime = HeadMan->DateTimeOut();
         IdxStr = LastMixDateTime+" "+HeadMan->GetDat("Subject: ",msg)+"                                                  ";
         IdxStr = IdxStr.SubString(1,53)+CntStr+LastMixFeedback->Strings[LastMixCount-1].Trim();
         GetAppData(log,ChainLog); log->Add(IdxStr);
         int max=GetAppIni(ChainLogMax,"").ToIntDef(16);
         while (max && log->Count>max)
            log->Delete(0);
         PutAppData(ChainLog,log);
         delete log;
         delete msg;
      }
      // if it is not a chain, do it
      // if it is a chain and also last in pool, do it
      // if it is chain and not last in pool, don't do it
      if (!isChain || (isChain && !MixPoolCount()))
      {
         TStringList *msg = new TStringList();
         TStringList *replay = new TStringList();
         GetAppData(msg,ProblemQueue + PS + GetMessageName());
         AnsiString Fcc = HeadMan->GetDat("Fcc: ", msg);
         HeadMan->Delete(WordWrapHeader, msg);

         if ((clrtxt=QSPoolHeaderToClearText(msg))>0)
         {
            replay->Text = msg->Text;
            QSPoolGet(msg,clrtxt);
         }

         if (!Fcc.IsEmpty())
         {
            HeadMan->Delete("Date: ");
            FileCopyMail(Fcc, msg);
         }

         if (IsNymConfigMessage(msg, NymConfigNym)) // && !IsNymDeleteMsg(msg))
         {
            HeadMan->Delete(NymConfigHdr); // in case any linger
            replay->Insert(0,"Sent: "+FormatDateTime("mm-dd-yyyy hh:nn:ss ampm", Now()));

            if (!FileExists(AppDir + "qsnym.exe"))
            {
               PutAppData(NymReplaysKey + PS + NymConfigNym, replay);
               PutAppData(NymConfigsKey + PS + NymConfigNym, msg);
            }
            else
            {
               assert(NymLogEntry != "");

               LogNymMessage(NymConfigNym, NymLogEntry);
               NewSaveReplay(NymConfigNym, replay);
            }
         }

         PutAppData(ProblemQueue + PS + GetMessageName(), NULL);
         delete replay;
         delete msg;
      }

      NymConfigNym = "";
    //NymLogEntry = "";
   }
   else // there may be a problem
   {
      if (!Aborted && !ProblemRpt->Count) ReturnCurrentToQueue();
      else SaveProblemMessage(GetMessageName(),ProblemRpt);
   }

   if (!Cancelled && (Messages->Count || MixPoolCount()))
   {
      PostMessage(Handle, WM_NEXTMESSAGE, 0, 0L);
      return;
   }

   ShowExitInfo();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::SaveProblemMessage(AnsiString MsgName, TStrings *Problems)
{
   int p,index;
   AnsiString s;//=Problems->Text; Problems->Text=s;
   TStringList *msg = new TStringList();
   GetAppData(msg,ProblemQueue+PS+MsgName); TrimNulls(msg);
   if (msg->Text.Trim().IsEmpty() ||
      (msg->Count && msg->Strings[0][1]!='#' && Problems->Count))
   {
      delete msg;
      return;
   }
   TStringList *probs = new TStringList();
   for (int i=0; i<Problems->Count; i++)
   {
      s = Problems->Strings[i].TrimRight();
      while ((p=s.Pos("\r"))>0) s.Delete(p,1);
      while ((p=s.Pos("\n"))>0) s.Delete(p,1);
      AddString(s,probs,50);
      probs->Add("");
   }
   //if (!msg->Count) msg->Add("");
   // handle special headers
   THeaderManager *hm = new THeaderManager(msg);
   if ((index=hm->IndexOf(WordWrapHeader))>=0) msg->Delete(index);
   if (msg->Count)
   {
      int idx=0;
      msg->Insert(idx++,"######################################################");
      msg->Insert(idx++,"#");
      for (int i=0; i<probs->Count; i++)
         msg->Insert(idx++,"#  "+probs->Strings[i]);
      msg->Insert(idx++,"#");
   }
   PutAppData(ProblemQueue+PS+MsgName,msg);
   Problems->Clear();
   delete probs;
   delete msg;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::PopPrintItemClick(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,"Send this transcript to the printer?","Confirm",MB_OKCANCEL)==IDOK)
     PrintMessage(Display->Lines,Display->Font,"QuickSilver SMTP Transcript",this);
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::TapQueues()
{
   Application->MainForm->Perform(WM_PROBLEMCHANGE,0,NULL);
   Application->MainForm->Perform(WM_QUEUECHANGE,0,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::SaveSMTPlog()
{
   TStringList *list = new TStringList();
   GetAppData(list,SMTPLog);
   int max = GetAppIni(SMTPLogMax,"").ToIntDef(16);
   while (max && list->Count>=max)
   {
      PutAppData(SMTPLog+PS+list->Strings[0],NULL);
      list->Delete(0);
   }
   AnsiString logstr = SMTPPOP3logtime();
   if (Display->Lines->Text.Pos("All mail sent"))
      logstr += " All mail sent";
   else
   if (Display->Lines->Text.Pos("Aborting..."))
      logstr += " Error: send aborted";
   else
   if (Display->Lines->Text.Pos("Send cancelled by user!"))
      logstr += " Send cancelled by user";
   PutAppData(SMTPLog+PS+logstr,Display->Lines);
   delete list;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::SetEditRect()
{
   TRect Rct = Rect(3,0,Display->ClientWidth-3,ClientHeight);
   Display->Perform(EM_SETRECT,0,long(&Rct));
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::FormResize(TObject *Sender)
{
   HelpBtn->Left = Width-HelpBtn->Width-20;
   CancelBtn->Left = HelpBtn->Left-CancelBtn->Width-8;
   SendBtn->Left = CancelBtn->Left-SendBtn->Width-8;
   AuthBtn->Left = SendBtn->Left-AuthBtn->Width-8;
   ProgressBar->Width = CancelBtn->Left-30;
   SetEditRect();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::FormPaint(TObject *Sender)
{
   SetEditRect();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::Timer2Timer(TObject *Sender)
{
   if (ProgressBar->Position<100) ProgressBar->Position += (WORD)1;
   else ProgressBar->Position = 20;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::PopCopyItemClick(TObject *Sender)
{
   Display->CopyToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::PopupMenu1Popup(TObject *Sender)
{
   PopCopyItem->Enabled = Display->SelLength>0;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("SMTPErrors","I can't send my mail!","");
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::SendBtnClick(TObject *Sender)
{
   Aborted = Cancelled = false;
   Messages->Sorted = true;
   GetAppData(Messages,MailQueue);
   Messages->Sorted = false;
   if (!Messages->Count)
   {
      BingBox(this,"   Nothing left to send!                    ","SMTP",MB_OK);
      return;
   }
   SendBtn->Visible = false;
   AuthBtn->Visible = false;

   CancelBtn->Caption = "Cancel";
   Display->Clear(); curmsg = LastError = 0;
   PostMessage(Handle,WM_NEXTMESSAGE,0,0L);
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::AuthBtnClick(TObject *Sender)
{
   ManageSMTPPasswords(this);
}
//---------------------------------------------------------------------------

void __fastcall TSmtpDlg::SMTPResponse(TObject *Sender, AnsiString Msg)
{
   // This function uses AuthType (set in PrepairMail) as a flag that auth is required. If not CRAM-MD5 check others.
   if (Msg.Pos("250") == 1 && Msg.Pos("AUTH") == 5 && SMTP->AuthType == smtpAuthCramMD5)
   {
      if (Msg.Pos("CRAM-MD5") == 0)
      {
         if (Msg.Pos("LOGIN") > 0)
            SMTP->AuthType = smtpAuthLogin;
         else
         if (Msg.Pos("PLAIN") > 0)
            SMTP->AuthType = smtpAuthPlain;
      }
   }
}
//---------------------------------------------------------------------------
