/*
*  SmtpDlgs.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#ifndef SmtpDlgsH
#define SmtpDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include <vcl\Buttons.hpp>
#include "SmtpProt.hpp"

#include "MixMsg.h"
#include "Global.h"
//---------------------------------------------------------------------------
bool __fastcall SendMail(bool AndClose = false);
bool __fastcall UpdateStatsOnSend();
void __fastcall RegisterStatsUpdated();
bool __fastcall QueueHasChainMail();
void __fastcall SetQueueHasChainMail(bool state);
bool __fastcall IsNymConfigMessage(TStrings *Message, AnsiString &nym);
void __fastcall AddString(AnsiString &String, TStrings *Strings, int WordWrapAt);
bool __fastcall WrapMessage(TStrings *Msg, int AtCol);
void __fastcall OpenMail2DiskDirectory(TForm *Owner, AnsiString &Directory);
AnsiString __fastcall SMTPPOP3logtime();
const AnsiString Shit = "Curses!";

class TSmtpDlg : public TForm
{
__published:	// IDE-managed Components
	//TSmtpCli *SMTP;
   TPanel *Panel1;
   TButton *CancelBtn;
   TPanel *Panel2;
   TRichEdit *Display;
   TProgressBar *ProgressBar;
   TPopupMenu *PopupMenu1;
   TMenuItem *PopPrintItem;
   TTimer *Timer2;
   TMenuItem *PopCopyItem;
   TButton *HelpBtn;
   TBitBtn *SendBtn;
   TButton *AuthBtn;
   TSmtpCli *SMTP;
   void __fastcall FormShow(TObject *Sender);
   void __fastcall SMTPDisplay(TObject *Sender, AnsiString Msg);
	//void __fastcall SMTPGetData1(TObject *Sender, int LineNum, Pointer MsgLine,
	//   int MaxLen, bool &More);
   void __fastcall SMTPRequestDone(TObject *Sender, TSmtpRequest RqType,
       WORD Error);
   void __fastcall CancelBtnClick(TObject *Sender);
   void __fastcall SMTPProcessHeader(TObject *Sender, TStrings *HdrLines);
   void __fastcall SMTPSessionClosed(TObject *Sender, WORD Error);
   void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
   void __fastcall PopPrintItemClick(TObject *Sender);
   void __fastcall FormResize(TObject *Sender);
   void __fastcall FormPaint(TObject *Sender);
   void __fastcall Timer2Timer(TObject *Sender);
   void __fastcall PopCopyItemClick(TObject *Sender);
   void __fastcall PopupMenu1Popup(TObject *Sender);
   void __fastcall HelpBtnClick(TObject *Sender);
   void __fastcall SendBtnClick(TObject *Sender);
   void __fastcall AuthBtnClick(TObject *Sender);
   void __fastcall SMTPGetData(TObject *Sender, int LineNum, Pointer MsgLine,
      int MaxLen, bool &More);
   void __fastcall SMTPResponse(TObject *Sender, AnsiString Msg);
private:	// User declarations
   void __fastcall ExceptionHandler(TObject *Sender, Exception *E);
public:		// User declarations
   int curmsg, LastError;
   bool Cancelled, Aborted, Excepted, Rset, AndClose;
   bool HeadDone, BodyDone, IsNymConfig, InEHLO, UseSocks;
   AnsiString SocksServer, SocksPort, SocksLevel, TORSignOn, proxyname;
   //TMimeMan *MimeMan;
   //THeaderManager *HeadMan;
   TMixMessage *MixMan;
   TStringList *Original;
   TStringList *Message;//,*test;
   TStringList *Messages;
   AnsiString MessageName,MessageNameOrg;
   TStringList *Head,*Body,*bak,*ProblemRpt,*specialheaders;
   int BytesTotal,BytesSent;
   TStringList *ProcessLog;  // obsolete
   TStringList *LastMixFeedback;
   AnsiString LastMixDateTime,NymConfigNym,NymLogEntry,Send2Dir;
   int LastMixCount;
   AnsiString FontName; int FontSize;
   virtual __fastcall TSmtpDlg(TComponent* Owner);
   virtual __fastcall ~TSmtpDlg();
   int __fastcall Execute();
   void __fastcall Cancel();
   void __fastcall Abort(WORD Error=0);
   void __fastcall Except(Exception *E);
   void __fastcall ReturnCurrentToQueue();
   void __fastcall ShowExitInfo();
   void __fastcall DoSendMessage();
   int  __fastcall GetHeaders();
   void __fastcall SetSessionProxy(const AnsiString &name);
   void __fastcall GetSpecialHeaders(TStrings *message);
   void __fastcall FileCopyMail(AnsiString &ToMailbox,TStrings* Message);
   // procedures used in SendMessage()
   bool __fastcall CutMessageAtMark();
   bool __fastcall CheckUsingSocks(TStrings *message);
   bool __fastcall GetNextMessage();
   void __fastcall GoNext();
   bool __fastcall MoveRecipsToCC(TStrings *message);
   bool __fastcall HasHeader(AnsiString &Header, TStrings *message);
   long __fastcall DoMixmasterMessage(TStrings *message);
   AnsiString __fastcall GetMessageName(); // returns MessageName or MessageNameOrg
   bool __fastcall PrepareMail();
   bool __fastcall IsPgpSignedMessage(TStrings *msg);
   bool __fastcall DupleRemailers(AnsiString &keyring, AnsiString &typfile);
   void __fastcall MassageNewsgroupsAndReferencesAndSubject();
   void __fastcall SaveProblemMessage(AnsiString MsgName, TStrings *Problems);
   void __fastcall TapQueues(); // sends messages to affect queue/problem buttons
   AnsiString __fastcall SendingCurrentMessageString();
   void __fastcall SendMessageToDirectory();
   void __fastcall SetEditRect();
   void __fastcall SaveSMTPlog();
   bool __fastcall SendMailToDirectory();
   void __fastcall LogNymMessage(AnsiString nym, AnsiString entry);

   //bool __fastcall CheckFailHashCash(THeaderManager *HeadMan);
   //bool __fastcall AddHashCashToHeaders(THeaderManager *HeadMan, const AnsiString &GateWay);
   // SMTP authentication
   bool __fastcall HasAUTHCommand(AnsiString &Mechanism);
   bool __fastcall NeedsSMTPAuthentication(AnsiString host, AnsiString &userid,
      AnsiString &password);
   void __fastcall NewSaveReplay(AnsiString nym, TStrings *replay);
   // message functions
   void virtual __fastcall WMNextMessage(TMessage& Msg);
   // message map
   BEGIN_MESSAGE_MAP
   MESSAGE_HANDLER(WM_NEXTMESSAGE,TMessage,WMNextMessage)
   END_MESSAGE_MAP(TForm)
};

//---------------------------------------------------------------------------
extern TSmtpDlg *SmtpDlg;
//---------------------------------------------------------------------------
#endif
