/*
*  UPDFtpDlg.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <filectrl.hpp>
#pragma hdrstop

#include "UPDFtpDlg.h"
#include "FileMan.h"
#include "global.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "Ftpcli"
#pragma resource "*.dfm"
TUPDftpDlg *UPDftpDlg;
#define TEMP_FILE_NAME "FTPDir.TXT"
//---------------------------------------------------------------------------

bool __fastcall GetQSUpdateList(TComponent *Owner, TStrings *FTPInfo, TStrings *Proxy,
   TStrings *FileList)
{
   bool ok = false;
   FileList->Clear();
   int p, c = 0;

//view(Proxy);
   AnsiString proxy = Proxy->Text;
   while ((p = proxy.Pos("%ftphost%")) > 0)
   {
      proxy.Delete(p, 9);
      proxy.Insert(FTPInfo->Values["hostname"], p);
      c++;
   }
   if (c > 0)
      Proxy->Text = proxy;

   UPDftpDlg = new TUPDftpDlg(Owner, FTPInfo, Proxy);

   if (UPDftpDlg->GetUpdateList()==mrOk && FileExists(TEMP_FILE_NAME))
   {
      TStringList *tmp = new TStringList();
      UPDftpDlg->ParseFileList(tmp);
      FileList->Text = tmp->Text;
      delete tmp;
      ok = true;
   }

   if (FileExists(TEMP_FILE_NAME))
      DeleteFile(TEMP_FILE_NAME);

   delete UPDftpDlg;
   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall GetQSUpdate(TComponent *Owner, TStrings *FTPInfo, TStrings *Proxy)
{
   bool ok=false;
   AnsiString LocalFileName = FTPInfo->Values["LocalFileName"];
   UPDftpDlg = new TUPDftpDlg(Owner, FTPInfo, Proxy);

   if (UPDftpDlg->GetUpdate()==mrOk && FileExists(LocalFileName))
   {
      ok=true;
   }

   delete UPDftpDlg;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TUPDftpDlg::TUPDftpDlg(TComponent *Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------

__fastcall TUPDftpDlg::TUPDftpDlg(TComponent *Owner, TStrings *FTPInfo, TStrings *Proxy)
   : TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner);
   FTP->Port = FTPInfo->Values["hostport"];
   FTP->HostDirName = FTPInfo->Values["hostdir"];
   FTP->HostName = FTPInfo->Values["hostname"];
   FTP->UserName = "anonymous";                      //FTPInfo->Values["UserName"];
   FTP->PassWord = "nobody@nowhere.net";             //FTPInfo->Values["Password"];
   FTP->Passive = FTPInfo->Values["passive"] == "1";
   FTP->HostFileName = FTPInfo->Values["hostfilename"];
   FTP->LocalFileName = FTPInfo->Values["localfilename"];
   Filesize = FTPInfo->Values["filesize"].ToIntDef(0);
   FTP->ConnectionType = ftpDirect;

   FTP->ControlSocket->SocksServer = "";
   FTP->ControlSocket->SocksPort = "";
   FTP->ControlSocket->SocksLevel = "4";
   FTP->ControlSocket->SocksPassword = "";
   FTP->ControlSocket->SocksUsercode = "";
   FTP->ControlSocket->SocksAuthentication = socksNoAuthentication;

   proxyname = GetToken(0, Proxy->Values["name"], ",");
   if (proxyname.IsEmpty())
      proxyname = "<none>";

   AnsiString proxyhost = Proxy->Values["host"];
   if (proxyhost.IsEmpty())
      proxyhost = "<none>";

   if (Proxy->Count && proxyhost != "<none>")
   {
      AnsiString socksver = Proxy->Values["socksver"].LowerCase();
      if (socksver == "4" || socksver == "4a" || socksver == "5")
      {
         FTP->ConnectionType = ftpSocks4;
         if (socksver == "4a") FTP->ConnectionType = ftpSocks4A; else
         if (socksver == "5" ) FTP->ConnectionType = ftpSocks5;

         FTP->SocksServer = proxyhost;
         FTP->SocksPort = Proxy->Values["ftpport"];

         if (Proxy->Values["auth"] == "1")
         {
            FTP->SocksPassword = Proxy->Values["password"];
            FTP->SocksUserCode = Proxy->Values["userid"];
         }
      }
      else
      {
         FTP->ConnectionType = ftpProxy;
         FTP->ProxyServer = proxyhost;
         FTP->PassWord = Proxy->Values["password"];
         FTP->UserName = Proxy->Values["userid"];
      }
   }

   TimeOut->Interval = GetAppIni(UpdateWizTimeout,"").ToIntDef(30) * 1000;
   FTP->Timeout = TimeOut->Interval + 30; // just make it high enough to not happen.
   BytesTotal = 0;
   Cancel = false;
   Label1->Caption = "";
}
//---------------------------------------------------------------------------

int __fastcall TUPDftpDlg::GetUpdateList()
{
   Display->Clear();
   Display->Lines->Add("Proxy: " + proxyname);
   Display->Lines->Add("Connecting...");
   FTP->LocalFileName = TEMP_FILE_NAME;
   TimeOut->Enabled = true;
   FTP->DirectoryAsync();
   return ShowModal();
}
//---------------------------------------------------------------------------

int __fastcall TUPDftpDlg::GetUpdate()
{
   Display->Clear();
   Display->Lines->Add("Proxy: " + proxyname);
   Display->Lines->Add("Connecting...");
   BytesTotal = Filesize;
   TimeOut->Enabled = true;
   FTP->ReceiveAsync();
   return ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TUPDftpDlg::ParseFileList(TStringList *Results)
{
   Results->Clear();
   AnsiString name,date,size,entry,ext,tmp,fld;
   if (FileExists(TEMP_FILE_NAME))
   {
      TStringList *dir = new TStringList();
      dir->LoadFromFile(TEMP_FILE_NAME); DeleteFile(TEMP_FILE_NAME);
      for (int i=0; i<dir->Count; i++)
      {
         entry = dir->Strings[i];
         name = GetParam(8,entry," ");
         tmp = name.LowerCase();
         ext = ExtractFileExt(name).LowerCase();

         if (ext!=".exe" && ext!=".zip" && ext!=".txt") continue;

         for (int i=5; i<8; i++)
         {
            fld = GetParam(i,entry," ");
            if (i==6 && fld.Length()<2) fld = " "+fld;
            date = date+" "+fld;
         }
         size=GetParam(4,entry," ");
         while (size.Length() <  8) size = " "+size;
         while (name.Length() < 11) name += " ";
         Results->Add(name + "," + size + "," + date);
         date = "";
      }
      delete dir;
   }
}
//---------------------------------------------------------------------------

void __fastcall TUPDftpDlg::FTPRequestDone(TObject *Sender, TFtpRequest RqType, WORD Error)
{
   AnsiString tmp,name;
   LastError = Error;
   if (Error && Error != 226)
   {
      FTPDisplay(Sender,"Error = " + IntToStr(Error) + " (" + FTP->ErrorMessage + ")");
      CancelBtn->Caption = "Close";
      TimeOut->Enabled = false;
      return;
   }
   switch (RqType)
   {
      case ftpDirectoryAsync:
         if (Cancel || LastError && LastError != 226)
         {
            if (FileExists(TEMP_FILE_NAME)) DeleteFile(TEMP_FILE_NAME);
            MyBeep(MB_ICONHAND);
            break;
         }
         TimeOut->Enabled = false;
         ModalResult = mrOk;
         Finished = true;
         break;

      case ftpReceiveAsync:
         if (Cancel || LastError)
         {
            if (BytesReceived<BytesTotal && FileExists(FTP->LocalFileName))
            {
               Display->Lines->Add("Deleting "+ExtractFileName(FTP->LocalFileName)+"...");
               DeleteFile(FTP->LocalFileName.c_str());
            }
            MyBeep(MB_ICONHAND);
            break;
         }
         TimeOut->Enabled = false;
         ModalResult = mrOk;
         Finished = true;
         break;
   }
}
//---------------------------------------------------------------------------

void __fastcall TUPDftpDlg::FTPDisplay(TObject *Sender, AnsiString &Msg)
{
   TimeOut->Enabled = false;
   if (!Cancel)
   {
      Display->Lines->Add(Msg);
      TimeOut->Enabled = true;
   }
}
//---------------------------------------------------------------------------

void __fastcall TUPDftpDlg::FTPProgress(TObject *Sender, long Count, bool &Abort)
{
   TimeOut->Enabled = false;
   if (Cancel) Abort = true;
   if (!Abort && BytesTotal>0)
   {
      TimeOut->Enabled = true;
      Label1->Caption = AnsiString((int)Count)+" of "+AnsiString(BytesTotal)+" bytes ";
      ProgressBar1->Position = (Count/BytesTotal)*100;
      BytesReceived = Count;
   }
}
//---------------------------------------------------------------------------

void __fastcall TUPDftpDlg::CancelBtnClick(TObject *Sender)
{
   FTP->Abort();
   TimeOut->Enabled = false;
   if (CancelBtn->Caption=="Cancel")
   {
      Display->Lines->Add("");
      Display->Lines->Add("User cancelled operation...");
      MyBeep(MB_ICONHAND);
      Cancel = true;
      Sleep(1000);
   }
   ModalResult = mrCancel;
}
//---------------------------------------------------------------------------

void __fastcall TUPDftpDlg::FTPSessionClosed(TObject *Sender, WORD Error)
{
   TimeOut->Enabled = false;
   /*LastError = Error;
   if (Cancel)
   {
      Display->Lines->Add("");
      Display->Lines->Add("User cancelled operation...");
      MyBeep(MB_ICONHAND);
      Sleep(1000);
      ModalResult = mrCancel;
   }*/
}
//---------------------------------------------------------------------------

void __fastcall TUPDftpDlg::FTPSessionConnected(TObject *Sender, WORD Error)
{
   Display->Lines->Add("Connected");
}
//---------------------------------------------------------------------------

void __fastcall TUPDftpDlg::TimeOutTimer(TObject *Sender)
{
   FTP->Abort();
   TimeOut->Enabled = false;
   Display->Lines->Add("");
   Display->Lines->Add("Operation timed out...");
   BingBox(this,
      s("The connection has timed out! It may simply be that the site is overloaded,      \n")+
      s("and trying later will be successful. There is also another possibility. Do you   \n")+
      s("have a firewall?. If so, the firewall must to allow the opening of the DATA      \n")+
      s("port, not just the connection port."),
      s("Operation Timed Out"),
      MB_OK);
   Cancel = true;
}
//---------------------------------------------------------------------------

