/*
*  UPDateDlg.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
#include <filectrl.hpp>
#include <IniFiles.hpp>

//QS Updates  (QS*.exe,QS*.zip,Mix*.zip)|QS*.exe,QS*.zip,mix*.zip
//QuickSilver Updates  (QS*.exe)|QS*.exe|QSplugin Updates (QS*.zip)|QS*.ZIP|Mixmaster Updates (mix*.zip)|mix*.zip
#include "UPDateDlg.h"
#include "UPDunzipDlg.h"
#include "UPDedDlg.h"
#include "UPDftpDlg.h"
#include "UPDhistDlgs.h"
#include "global.h"
#include "dir.h"
#include "fileman.h"
#include "qs1\QSver.h"
#include "pop3mail.h"
#include "pgpmail.h"
#include "nymmail.h"
#include "newsmail.h"
#include "wipedlgs.h"
//---------------------------------------------------------------------------
#pragma link "Ftpcli"
#pragma resource "*.dfm"
TUPDateQsDlg *UPDateQsDlg;
#define TEMP_FILE_NAME "FTPDIR.TXT"
//---------------------------------------------------------------------------

AnsiString __fastcall RunUpdateExpress(TForm *MainForm, bool &Cancel)
{
   Cancel = false;
   AnsiString RunProgramOnExit,filename,ext;
   UPDateQsDlg = new TUPDateQsDlg(MainForm);
   UPDateQsDlg->MainForm = MainForm;
   UPDateQsDlg->ShowModal();
   int mrResult=UPDateQsDlg->ModalResult;
   if (mrResult==mrOk)
   {
      filename = UPDateQsDlg->LocalName.LowerCase();
      ext = ExtractFileExt(filename);
      if (ext==".zip")
      {
         if (UPDateQsDlg->IsMixmaster) RunProgramOnExit = AppExeName+" -mix \""+filename+"\"";
         else if (UPDateQsDlg->runQS) RunProgramOnExit = AppExeName;
      }
      if (ext==".exe") RunProgramOnExit = UPDateQsDlg->LocalName;
   }
   else
      Cancel = true;
   delete UPDateQsDlg;
   return RunProgramOnExit;
}
//---------------------------------------------------------------------------

__fastcall TUPDateQsDlg::TUPDateQsDlg(TComponent* Owner)
  : TForm(Owner)
{
   Notebook1->PageIndex = 0;
   ListBox1->Align = alClient;

   AnsiString file = "local file";
   AnsiString quik = "ftp.quicksilvermail.net/pub/quicksilver";
   AnsiString skuz = "ftp.skuz.net/pub/quicksilver";

   FTPinfo = new TStringList();
   GetAppData(FtpSite->Items,UpdateSites);
   if (FtpSite->Items->IndexOf(file) < 0) FtpSite->Items->Add(file);
   if (FtpSite->Items->IndexOf(quik) < 0) FtpSite->Items->Insert(0, quik);
   if (FtpSite->Items->IndexOf(skuz) < 0) FtpSite->Items->Insert(1, skuz);
   FtpSite->ItemIndex = 0;
   FtpSiteChange(NULL);

   Proxy = new TStringList();
   Proxies = new TStringList();
   TIniFile *ini = new TIniFile(AppIni);
   GetProxies(ini);
   delete ini;

   HostDir->Clear();

   // local file stuff
   AnsiString dir = AppDir+"updates";
   if (!DirectoryExists(dir)) dir = AppDir;
   DirectoryListBox1->Directory = dir;
   FilterComboBox1->Filter = "QS*.exe QS*.zip Mix*.zip|QS*.EXE;QS*.ZIP;MIX*.ZIP";

//sm(GetAppIni(FtpProxy,"").ToIntDef(0));

   CenterDialog(this,(TForm*)Owner);
   IsMixmaster = false;
   DbEncrypted = false;
   runQS = false;

   GetQSModuleVersions();
}
//---------------------------------------------------------------------------

__fastcall TUPDateQsDlg::~TUPDateQsDlg()
{
   int checkedProxy=ClassProxy->Checked?1:TransProxy->Checked?2:UserProxy->Checked?3:0;
   PutAppIni(FtpProxy, AnsiString(checkedProxy));

   delete FTPinfo;
   delete Proxies;
   delete Proxy;
}
//---------------------------------------------------------------------------

void __fastcall TUPDateQsDlg::GetProxies(TIniFile *ini)
{
   TStringList *proxies = new TStringList();

   GetAppData(proxies, "proxies");
   ProxyBox->Items->Clear();
   ProxyBox->Sorted = true;
   Proxies->Clear();
   Proxies->Sorted = true;

   for (int i = 0; i < proxies->Count; i++)
   {
      AnsiString line = proxies->Strings[i];
      int x; while ((x = line.Pos("\255")) > 0)
         line[x] = '/';

      if (GetToken(6, line, ",") != " ")
      {
         ProxyBox->Items->Add(GetToken(0, line, ","));
         Proxies->Add(line);
      }
   }

   delete proxies;

   Proxies->Sorted = false;
   ProxyBox->Sorted = false;
   ProxyBox->Items->Insert(0, "<none>");
   Proxies->Insert(0, "<none>");

   AnsiString last = GetAppIni("ftpproxy", "<none>");
   int index = Proxies->IndexOf(last);
   if (index < 0)
   {
      index = 0;
      MsgDlg(this,
         "The proxy you have been using for FTP retrieval: " + last + "      \n"
         "is no longer present!",
         "Warning",
          MB_OK
      );
   }

   ProxyBox->ItemIndex = index;
   ProxyBoxChange(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TUPDateQsDlg::ProxyBoxChange(TObject *Sender)
{
   AnsiString proxy = Proxies->Strings[ProxyBox->ItemIndex];
   PutAppIni("ftpproxy", proxy);

   if (proxy == "<none>") Proxy->Clear();
   else GetAppData(Proxy, "proxies" + PS + proxy);
}
//---------------------------------------------------------------------------

AnsiString __fastcall GetModuleVersion(const AnsiString &section, const AnsiString &IniFile)
{
   TIniFile *ini = new TIniFile(AppDir + IniFile);

   AnsiString version = ini->ReadString(section, "version", "error");
   if (version == "error")
      version = ini->ReadString("main", "version", "error");
   delete ini;

   return version;
}
//---------------------------------------------------------------------------

void __fastcall TUPDateQsDlg::GetQSModuleVersions()
{
   Label12->Caption = "Current:   QS"+ReleaseVersion.Trim();
   if (HasPop3()) Label12->Caption = Label12->Caption + "   QSpop"+GetPop3Version();
   if (HasNews()) Label12->Caption = Label12->Caption + "   QSnews"+GetNewsLibVersion();
   if (HasPgp() && !FileExists(AppDir + "qspgp.bpl"))
      Label12->Caption = Label12->Caption + "   QSpgp"+GetPgpLibVersion();
   if (HasNyms() && !FileExists(AppDir + "qsnym.exe"))
      Label12->Caption = Label12->Caption + "   QSnym"+GetNymLibVersion();

   if (FileExists(AppDir + "qspgp.exe"))
   {
      TIniFile *ini = new TIniFile(AppDir + "qspgp.ini");
      AnsiString version = ini->ReadString(PgpIni, "version", "-----");
      if (version == "-----")
         version = ini->ReadString("main", "version", "-----");
      Label12->Caption = Label12->Caption + "   QSpgp" + version;
      delete ini;
   }

   if (FileExists(AppDir + "qsstats.exe"))
   {
      TIniFile *ini = new TIniFile(AppDir + "qsstats.ini");
      AnsiString version = ini->ReadString(StatsIni, "version", "-----");
      if (version == "-----")
         version = ini->ReadString("main", "version", "-----");
      Label12->Caption = Label12->Caption + "   QSstats" + version;
      delete ini;
   }

   if (FileExists(AppDir + "qsnym.exe"))
   {
      TIniFile *ini = new TIniFile(AppDir + "qsnym.ini");
      AnsiString version = ini->ReadString(NymIni, "version", "-----");
      if (version == "-----")
         version = ini->ReadString("main", "version", "-----");
      Label12->Caption = Label12->Caption + "   QSnym" + version;
      delete ini;
   }

   if (FileExists(AppDir + "qsproxy.exe"))
   {
      TIniFile *ini = new TIniFile(AppDir + "qsproxy.ini");
      AnsiString version = ini->ReadString(ProxyIni, "version", "-----");
      if (version == "-----")
         version = ini->ReadString("main", "version", "-----");
      Label12->Caption = Label12->Caption + "   QSproxy" + version;
      delete ini;
   }

   if (FileExists(AppDir + "qsreports.exe"))
   {
      TIniFile *ini = new TIniFile(AppDir + "qsreports.ini");
      AnsiString version = ini->ReadString(ReportsIni, "version", "-----");
      if (version == "-----")
         version = ini->ReadString("main", "version", "-----");
      Label12->Caption = Label12->Caption + "   QSreports" + version;
      delete ini;
   }
}
//---------------------------------------------------------------------------

bool __fastcall TUPDateQsDlg::IsMixmasterUpdate(AnsiString &Filename)
{
   if (!FileExists(Filename)) return false;
   AnsiString name=ExtractFileName(Filename).LowerCase(),ext=ExtractFileExt(name);
   if (name.SubString(1,6)=="mix29b" && ext==".zip") return true;
   if (name.SubString(1,4)=="mix3" && ext==".zip") return true;
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TUPDateQsDlg::Exec95Zip(AnsiString &ZipFileName)
{
   return UnzipQSPlugins(MainForm,ZipFileName,runQS);
}
//---------------------------------------------------------------------------

bool __fastcall TUPDateQsDlg::Exec95Txt(AnsiString &TxtFileName)
{
   UPDHistDlg = new TUPDHistDlg(this);
   if (FileExists(TxtFileName))
      UPDHistDlg->RichEdit1->Lines->LoadFromFile(TxtFileName);
   UPDHistDlg->Caption = ExtractFileName(TxtFileName);
   UPDHistDlg->ShowModal();
   delete UPDHistDlg;
   return true;
}
//---------------------------------------------------------------------------

void __fastcall TUPDateQsDlg::NextBtnClick(TObject *Sender)
{
   static AnsiString name;
   AnsiString ext,updateinfo,info,host,size,updir,proxy;
   switch (Notebook1->PageIndex)
   {
      case 0:
         if (FtpSite->Text.LowerCase()=="local file")
         {
            NextBtn->Enabled = false;
            NextBtn->Caption = "Run Setup";
            BackBtn->Enabled = true;
            Notebook1->PageIndex = 3;
            FileListBox1Click(NULL);
         }
         else
         {
            if (GetQSUpdateList(this, FTPinfo, Proxy, ListBox1->Items))
            {
               Application->ProcessMessages(); Sleep(300);
               CancelBtn->Enabled = Notebook1->PageIndex < 2;
               NextBtn->Enabled = false;
               BackBtn->Enabled = true;
               Notebook1->PageIndex++;
               MyBeep(MB_OK);
            }
         }
         break;
      case 1:
         updateinfo = ListBox1->Items->Strings[ListBox1->ItemIndex];
         info = GetToken(0,updateinfo.LowerCase(),",");
         if (info.Pos("qsnym.")==1 && ExtractFileExt(info)==".zip")
         {
             if (!HasPgp() && BingBox(this,
                s("I see you are getting the QuickSilver QSnym plugin. I also noticed\n")+
                s("you do not have the QSpgp plugin installed. I can get the nym plugin\n")+
                s("now and install it--that's not a problem--but you will not find it available\n")+
                s("for use until you install the QSpgp plugin.\n\n")+
                s("Also, you'll need some version of PGP. With QSpgp and QSnym installed,\n")+
                s("take a look at the help topic 'Nym Wizard, Your Nym's PGP Key'. You'll\n")+
                s("find an ftp site noted where you can get PGP.\n\n")+
                s("      Get the QSnym plugin now?"),
                s("Information"),MB_OKCANCEL)==IDCANCEL)
                   break;
             Snooze(400);
             if (!HasNyms() && BingBox(this,
                s("\nHi! Sorry to bother. I see you are preparing to install the QSnym plugin for the first time.\n")+
                s("I must caution you the learning curve on this module is significantly steeper than the rest\n")+
                s("of the QS program. It requires some knowledge of nyms. If you have just gotten QS quite\n")+
                s("recently and wish to get into nyms quick as possible, please reconsider. Take some time\n")+
                s("to learn how QS operates. Learn what you can about nyms on the net and in the\n")+
                s("newsgroup, alt.privacy.anon-server. Searching a.p.a-s at google for nym info provides a\n")+
                s("wealth of knowledge of both QS and nyms in general. Start with most recent dates. Also\n")+
                s("of great value is the web page, 'http://quicksilver.skuz.net/help@nym.alias.net.html'.\n")+
                s("This page provides the actual instructions on creating a nym manually. You need to know\n")+
                s("what QS is doing for you.\n\nDo you still want to get the QSnym plugin, now? \n \n "),
                s("Hold up there, Pard'"),MB_OKCANCEL)==IDCANCEL)
                   break;
         }
         name = GetParam(0,updateinfo,",").Trim();
         size = GetParam(1,updateinfo,",").Trim();
         ext = ExtractFileExt(name);
         updir = AppDir+"updates\\";
         if (!DirectoryExists(updir.c_str())) ForceDirectories(updir.c_str());
         if (!DirectoryExists(updir.c_str()))
         {
            MsgBoxHwnd(Handle,
               "Unable to create destination directory!\n("+updir+")",
               "Create Directory",
                MB_OK
            );
            break;
         }
         LocalName = updir+name;
         FTPinfo->Values["LocalFileName"] = LocalName;
         FTPinfo->Values["HostFileName"] = name;
         FTPinfo->Values["FileSize"] = size;
         if (FileExists(LocalName)) zapfile(LocalName,1);
         if (GetQSUpdate(this, FTPinfo, Proxy))
         {
            if (ExtractFileExt(LocalName).LowerCase()==".txt")
            {
               Exec95Txt(LocalName);
               break;
            }
            Label6->Caption = LocalName.LowerCase();
            if (IsMixmasterUpdate(LocalName))
               Label3->Caption =
                  "Just run the Mixmaster Setup program, and you're finished!";
            Application->ProcessMessages(); Sleep(300);
            NextBtn->Enabled = true;
            NextBtn->Caption = "Run Setup";
            BackBtn->Enabled = false;
            Notebook1->PageIndex++;
            MyBeep(MB_OK);
         }
         break;
      case 2:
         // this is for ftp updates
         Application->MainForm->Hide();
         Sleep(400); this->Hide(); Sleep(400);
         ext = ExtractFileExt(LocalName.LowerCase());
         if (IsMixmasterUpdate(LocalName)) IsMixmaster = true; else
         if (ext==".zip") Exec95Zip(LocalName);
         ModalResult = mrOk;
         break;
      case 3:
         // this is for local file updates
         Application->MainForm->Hide();
         Sleep(400); this->Hide(); Sleep(400);
         LocalName = FileListBox1->FileName.LowerCase();
         ext = ExtractFileExt(LocalName);
         if (IsMixmasterUpdate(LocalName)) IsMixmaster = true; else
         if (ext==".zip") Exec95Zip(LocalName.LowerCase());
         ModalResult = mrOk;
         break;
      case 4:
         if (GetQSUpdateList(this, FTPinfo, Proxy, ListBox1->Items))
         {
            Application->ProcessMessages(); Sleep(300);
            CancelBtn->Enabled = true;
            NextBtn->Enabled = false;
            BackBtn->Enabled = true;
            Notebook1->PageIndex = 1;
            MyBeep(MB_OK);
         }
         break;
   }
}
//---------------------------------------------------------------------------

void __fastcall TUPDateQsDlg::BackBtnClick(TObject *Sender)
{
   switch (Notebook1->PageIndex)
   {
      case 4:
      case 3:
         Notebook1->PageIndex = 0;
         break;
      default:
         Notebook1->PageIndex--;
   }

   switch (Notebook1->PageIndex)
   {
      case 0:
         NextBtn->Enabled = true;
         NextBtn->Caption = "Next";
         BackBtn->Enabled = false;
         break;
      case 1:
         NextBtn->Caption = "Next";
         NextBtn->Enabled = ListBox1->ItemIndex>=0;
         BackBtn->Enabled = true;
         break;
   }

   CancelBtn->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TUPDateQsDlg::EditBtnClick(TObject *Sender)
{
   UPDeditDlg = new TUPDeditDlg(this);
   CenterDialog(UPDeditDlg,this); UPDeditDlg->Top -= 8;
   UPDeditDlg->Memo1->Lines->Text = FtpSite->Items->Text;
   UPDeditDlg->ShowModal();
   if (UPDeditDlg->ModalResult==mrOk)
   {
      FtpSite->Items->Text = UPDeditDlg->Memo1->Lines->Text;
      if (FtpSite->Items->Count) FtpSite->ItemIndex = 0;
      PutAppData(UpdateSites,FtpSite->Items);
   }
   delete UPDeditDlg;
}
//---------------------------------------------------------------------------

void __fastcall TUPDateQsDlg::ListBox1Click(TObject *Sender)
{
   NextBtn->Enabled = ListBox1->ItemIndex>=0;
}
//---------------------------------------------------------------------------

void __fastcall TUPDateQsDlg::FileListBox1Click(TObject *Sender)
{
   NextBtn->Enabled = FileListBox1->ItemIndex>=0;
}
//---------------------------------------------------------------------------

void __fastcall TUPDateQsDlg::FtpSiteChange(TObject *Sender)
{
   FTPinfo->Clear();
   AnsiString host, port, site = FtpSite->Text.LowerCase();
   ProxyBox->Enabled = site != "local file";

   host = GetToken(0, site, "/");
   int pos = host.Pos(":");
   if (pos > 0)
   {
      port = host.SubString(pos + 1, 256);
      host = host.SubString(1, pos - 1);
   }
   if (port.IsEmpty())
      port = "21";

   FTPinfo->Values["hostdir"]  = site.SubString(site.Pos("/") + 1, 256);
   FTPinfo->Values["hostport"] = port;
   FTPinfo->Values["hostname"] = host;
   FTPinfo->Values["username"] = "anonymous";
   FTPinfo->Values["password"] = "nobody@nowhere.net";
   FTPinfo->Values["passive"]  = "1";
}
//---------------------------------------------------------------------------

void __fastcall TUPDateQsDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel && Notebook1->PageIndex>0)
   {
      if (MsgBoxHwnd(Handle,"Cancel QuickSilver update?","Confirm",MB_YESNO)==IDNO)
      {
         CanClose = false;
         return;
      }
   }
   SetCurrentDir(AppDir);
}
//---------------------------------------------------------------------------

void __fastcall TUPDateQsDlg::PopupMenuPopup(TObject *Sender)
{
   PopupDeleteItem->Enabled = FileListBox1->ItemIndex >= 0;
}
//---------------------------------------------------------------------------

void __fastcall TUPDateQsDlg::PopupDeleteItemClick(TObject *Sender)
{
   AnsiString thedir = FileListBox1->Directory+"\\";
   AnsiString thefile = FileListBox1->Items->Strings[FileListBox1->ItemIndex];
   if (MsgBoxHwnd(Handle,
      "Delete "+thefile+"\n\nAre you sure?","Delete Update",
       MB_OKCANCEL)==IDOK)
   {
      zapfile(thedir+thefile,1);
      FileListBox1->Update();
   }
}
//---------------------------------------------------------------------------

void __fastcall TUPDateQsDlg::ListBox1DrawItem(TWinControl *Control, int Index,
  TRect &Rect, TOwnerDrawState State)
{
   TRect r(Rect);
   AnsiString text=ListBox1->Items->Strings[Index];

   ListBox1->Canvas->TextRect(r,r.Left+4,r.Top,GetParam(0,text,","));
   r.Left += 182;
   ListBox1->Canvas->TextRect(r,r.Left+4,r.Top,GetParam(1,text,","));
   r.Left += 70;
   ListBox1->Canvas->TextRect(r,r.Left+4,r.Top,GetParam(2,text,","));
}
//---------------------------------------------------------------------------

void __fastcall TUPDateQsDlg::ListBox1DblClick(TObject *Sender)
{
   NextBtn->Click();
}
//---------------------------------------------------------------------------
