/*
*  newsubdlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "global.h"
#include "newsubdlgs.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TNewSubDlg *NewSubDlg;
//---------------------------------------------------------------------------

AnsiString __fastcall NewSubjectManual(TForm* Owner)
{
   AnsiString line;
   NewSubDlg = new TNewSubDlg(Owner);
   NewSubDlg->Caption = " New Item";
   NewSubDlg->ShowModal();
   if (NewSubDlg->ModalResult == mrOk)
   {
      line = NewSubDlg->Group->Text + "\255" +
         NewSubDlg->Subject->Text + "\255" +
         NewSubDlg->Passwd->Text;
   }

   delete NewSubDlg;
   return line;
}
//---------------------------------------------------------------------------

AnsiString __fastcall ViewSubject(TForm* Owner, const AnsiString Line)
{
   assert(!Line.IsEmpty());

   AnsiString line;
   NewSubDlg = new TNewSubDlg(Owner);
   NewSubDlg->Caption = " View Item";
   NewSubDlg->ActiveControl = NewSubDlg->CancelBtn;
   NewSubDlg->Group->Text = GetToken(0, Line, "\255");
   NewSubDlg->Group->ReadOnly = true;
   NewSubDlg->Group->ParentColor = true;
   NewSubDlg->Subject->Text = GetToken(1, Line, "\255");
   NewSubDlg->Subject->ReadOnly = true;
   NewSubDlg->Subject->ParentColor = true;
   NewSubDlg->Passwd->Text = GetToken(2, Line, "\255");
   NewSubDlg->Passwd->ReadOnly = true;
   NewSubDlg->Passwd->ParentColor = true;
   NewSubDlg->OkBtn->Visible = false;
   NewSubDlg->CancelBtn->Caption = "Ok";
   NewSubDlg->ShowModal();

   delete NewSubDlg;
   return line;
}
//---------------------------------------------------------------------------

AnsiString __fastcall EditSubjectManual(TForm* Owner, AnsiString Line)
{
   NewSubDlg = new TNewSubDlg(Owner);
   NewSubDlg->Caption = " Edit Item";
   NewSubDlg->Group->Text = GetToken(0, Line, "\255");
   NewSubDlg->Subject->Text = GetToken(1, Line, "\255");
   NewSubDlg->Passwd->Text = GetToken(2, Line, "\255");
   NewSubDlg->ShowModal();
   if (NewSubDlg->ModalResult == mrOk)
   {
      Line = NewSubDlg->Group->Text + "\255" +
         NewSubDlg->Subject->Text + "\255" +
         NewSubDlg->Passwd->Text;
   }

   delete NewSubDlg;
   return Line;
}
//---------------------------------------------------------------------------

__fastcall TNewSubDlg::TNewSubDlg(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TNewSubDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult == mrOk && Group->Text.IsEmpty() && Subject->Text.IsEmpty())
   {
      InfoBox(this, "Newsgroup and Subject are required fields!", MB_OK);
      CanClose = false;
      return;
   }
}
//---------------------------------------------------------------------------
