/*
*  pgpmail.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "pgpmail.h"
#include "pgpfiles.h"
#include "fileman.h"
#include "headman.h"
#include "cyberpunk.h"
#include "wipedlgs.h"
#include "global.h"
#include "view.h"

HINSTANCE hPgpLib=NULL;
//bool pgpshutdown = false;
//---------------------------------------------------------------------------

bool __fastcall HasPgp()
{
   return hPgpLib != NULL && FileExists(AppDir + "qspgp.exe");
}
//---------------------------------------------------------------------------

bool __fastcall HasPgpSdk()
{
   if (!HasPgp())
      return false;

   HASPGPSDK hassdk = (HASPGPSDK)GetProcAddress(hPgpLib, "@HasPgpSdk");
   assert(hassdk != NULL);

   return hassdk();
}
//---------------------------------------------------------------------------

bool __fastcall PgpInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, TForm *MainForm,
   HWND AppHandle)
{
   PGPINIT pgpinit = (PGPINIT)GetProcAddress(hPgpLib,"@PgpInit");
   assert(pgpinit != NULL);
   pgpinit(HMixLib, HSSLLib, MainForm, AppHandle);

   return true;
}
//---------------------------------------------------------------------------

void  __fastcall PgpInitAppAndScrn(TApplication *MainApp, TScreen *MainScrn)
{
   PGPINITAPPANDSCRN pgpappscr = (PGPINITAPPANDSCRN)GetProcAddress(hPgpLib,
      "@PgpInitAppAndScrn");
   assert(pgpappscr != NULL);
   pgpappscr(MainApp, MainScrn);
}
//---------------------------------------------------------------------------

void  __fastcall PgpOpenPersonalKeyring()
{
   PGPOPENPERSONALKEYRING pgpkeys = (PGPOPENPERSONALKEYRING)GetProcAddress(
      hPgpLib, "@PgpOpenPersonalKeyring");
   assert(pgpkeys != NULL);
   pgpkeys();
}
//---------------------------------------------------------------------------

void __fastcall PgpShutDown()
{
   PGPSHUTDOWN shutdown = (PGPSHUTDOWN)GetProcAddress(hPgpLib, "@PgpShutDown");
   assert(shutdown != NULL);
   shutdown();
}
//---------------------------------------------------------------------------

char* __fastcall GetPgpLibName()
{
   GET_PGPLIBNAME libname = (GET_PGPLIBNAME)GetProcAddress(hPgpLib,
      "@GetPgpLibName");
   assert(libname != NULL);
   return libname();
}
//---------------------------------------------------------------------------

char* __fastcall GetPgpLibVersion()
{
   GET_PGPLIBVERSION libver = (GET_PGPLIBVERSION)GetProcAddress(hPgpLib,
      "@GetPgpLibVersion");
   assert(libver != NULL);
   return libver();
}
//---------------------------------------------------------------------------

void  __fastcall PgpClearPassphraseCache()
{
   PGP_CLEARPASSPHRASECACHE clear = (PGP_CLEARPASSPHRASECACHE)GetProcAddress(
      hPgpLib, "@PgpClearPassphraseCache");
   assert(clear != NULL);
   clear();
}
//---------------------------------------------------------------------------

char* __fastcall PgpPath()
{
   PGP_PGPPATH path = (PGP_PGPPATH)GetProcAddress(hPgpLib, "@PgpPath");
   assert(path != NULL);
   return path();
}
//---------------------------------------------------------------------------

char* __fastcall PgpSignMessage(char *Message)
{
   PGP_SIGNMESSAGE sign = (PGP_SIGNMESSAGE)GetProcAddress(hPgpLib,
      "@PgpSignMessage");
   assert(sign != NULL);
   return sign(Message);
}
//---------------------------------------------------------------------------

char* __fastcall PgpEncryptMessage(char *Message)
{
   PGP_ENCRYPTMESSAGE encrypt = (PGP_ENCRYPTMESSAGE)GetProcAddress(hPgpLib,
      "@PgpEncryptMessage");
   assert(encrypt != NULL);
   return encrypt(Message);
}
//---------------------------------------------------------------------------

char* __fastcall PgpEncryptSignMessage(char *Message)
{
   PGP_ENCRYPTSIGNMESSAGE encsign = (PGP_ENCRYPTSIGNMESSAGE)GetProcAddress(
      hPgpLib, "@PgpEncryptSignMessage");
   assert(encsign != NULL);
   return encsign(Message);
}
//---------------------------------------------------------------------------

bool  __fastcall PgpGetEncryptList(TForm *Owner, TStrings *Recips, bool CanConv)
{
   PGP_GETENCRYPTLIST list = (PGP_GETENCRYPTLIST)GetProcAddress(hPgpLib,
      "@PgpGetEncryptList");
   assert(list != NULL);
   return list(Owner, Recips, CanConv);
}
//---------------------------------------------------------------------------

bool __fastcall PgpIsConventional(char* Message)
{
   PGP_ISCONVENTIONAL isconv = (PGP_ISCONVENTIONAL)GetProcAddress(hPgpLib,
      "@PgpIsConventional");
   assert(isconv != NULL);
   return isconv(Message);
}
//---------------------------------------------------------------------------

char* __fastcall PgpDecryptVerifyMessage(char *Message, bool ForceDialog)
{
   PGP_DECRYPTVERIFYMESSAGE decver = (PGP_DECRYPTVERIFYMESSAGE)GetProcAddress(
      hPgpLib,"@PgpDecryptVerifyMessage");
   assert(decver != NULL);
   return decver(Message, ForceDialog);
}
//---------------------------------------------------------------------------

char* __fastcall PgpVerifyMessage(char *Message)
{
   PGP_VERIFYMESSAGE ver = (PGP_VERIFYMESSAGE)GetProcAddress(hPgpLib,
      "@PgpVerifyMessage");
   assert(ver != NULL);
   return ver(Message);
}
//---------------------------------------------------------------------------

bool  __fastcall PgpCheckPGP6NeedsUpdate()
{
   PGP_CHECKPGP6NEEDSUPDATE check = (PGP_CHECKPGP6NEEDSUPDATE)GetProcAddress(
      hPgpLib,"@PgpCheckPGP6NeedsUpdate");
   assert(check != NULL);
   return check();
}
//---------------------------------------------------------------------------

bool  __fastcall PgpUpdateQSKeyrings()
{
   PGP_UPDATEQSKEYRINGS update = (PGP_UPDATEQSKEYRINGS)GetProcAddress(hPgpLib,
      "@PgpUpdateQSKeyrings");
   assert(update != NULL);
   return update();
}
//---------------------------------------------------------------------------

char* __fastcall PgpPubringPkr()
{
   PGP_PUBRINGPKR pubring = (PGP_PUBRINGPKR)GetProcAddress(hPgpLib,
      "@PgpPubringPkr");
   assert(pubring != NULL);
   return pubring();
}
//---------------------------------------------------------------------------

char* __fastcall PgpSecringSkr()
{
   PGP_SECRINGSKR secring = (PGP_SECRINGSKR)GetProcAddress(hPgpLib,
      "@PgpSecringSkr");
   assert(secring != NULL);
   return secring();
}
//---------------------------------------------------------------------------

bool  __fastcall PgpImportKeys(TForm *Owner, TPGPbuffer *ImpKeys,
   char* ImportDir)
{
   PGP_IMPORTKEYS impkeys = (PGP_IMPORTKEYS)GetProcAddress(hPgpLib,
      "@PgpImportKeys");
   assert(impkeys != NULL);
   return impkeys(Owner, ImpKeys, ImportDir);
}
//---------------------------------------------------------------------------

bool  __fastcall PgpExportKeys(TForm *Owner, TPGPbuffer *PublicKeys,
   TPGPbuffer *SecretKeys, char *SelectedKeyId, char *ExportDir)
{
   PGP_EXPORTKEYS expkeys = (PGP_EXPORTKEYS)GetProcAddress(hPgpLib,
      "@PgpExportKeys");
   assert(expkeys != NULL);
   return expkeys(Owner, PublicKeys, SecretKeys, SelectedKeyId, ExportDir);
}
//---------------------------------------------------------------------------



